{
 "cells": [
  {
   "cell_type": "markdown",
   "id": "7d1872e7-9778-4e56-afbb-9c14fdfc5ec3",
   "metadata": {},
   "source": [
    "# NBA Data Analysis"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "54052d2a-274b-417c-8582-0d953cefdb49",
   "metadata": {},
   "source": [
    "The dataset used, available at https://www.kaggle.com/datasets/justinas/nba-players-data, contains over than two decades of information about NBA players."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "id": "3c462c28-67d5-4117-bf40-b5e9a18b6f25",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "            <div id=\"kotlin_out_0\"></div>\n",
       "            <script type=\"text/javascript\">\n",
       "                            if(!window.kotlinQueues) {\n",
       "                window.kotlinQueues = {};\n",
       "            }\n",
       "            if(!window.kotlinQueues[\"DataFrame\"]) {\n",
       "                var resQueue = [];\n",
       "                window.kotlinQueues[\"DataFrame\"] = resQueue;\n",
       "                window[\"call_DataFrame\"] = function(f) {\n",
       "                    resQueue.push(f);\n",
       "                }\n",
       "            }\n",
       "            (function (){\n",
       "                var modifiers = [(function(script) {\n",
       "    script.src = \"https://cdn.jsdelivr.net/gh/Kotlin/dataframe@3db46ccccaa1291c0627307d64133317f545e6ae/core/src/main/resources/init.js\"\n",
       "    script.type = \"text/javascript\";\n",
       "})];\n",
       "                var e = document.getElementById(\"kotlin_out_0\");\n",
       "                modifiers.forEach(function (gen) {\n",
       "                    var script = document.createElement(\"script\");\n",
       "                    gen(script)\n",
       "                    script.addEventListener(\"load\", function() {\n",
       "                        window[\"call_DataFrame\"] = function(f) {f();};\n",
       "                        window.kotlinQueues[\"DataFrame\"].forEach(function(f) {f();});\n",
       "                        window.kotlinQueues[\"DataFrame\"] = [];\n",
       "                    }, false);\n",
       "                    script.addEventListener(\"error\", function() {\n",
       "                        window[\"call_DataFrame\"] = function(f) {};\n",
       "                        window.kotlinQueues[\"DataFrame\"] = [];\n",
       "                        var div = document.createElement(\"div\");\n",
       "                        div.style.color = 'darkred';\n",
       "                        div.textContent = 'Error loading resource DataFrame';\n",
       "                        document.getElementById(\"kotlin_out_0\").appendChild(div);\n",
       "                    }, false);\n",
       "                    \n",
       "                    e.appendChild(script);\n",
       "                });\n",
       "            })();\n",
       "            </script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "                <style>\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "                </style>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "   <div id=\"Q90Qfj\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"library\">\n",
       "       if(!window.letsPlotCallQueue) {\n",
       "           window.letsPlotCallQueue = [];\n",
       "       }; \n",
       "       window.letsPlotCall = function(f) {\n",
       "           window.letsPlotCallQueue.push(f);\n",
       "       };\n",
       "       (function() {\n",
       "           var script = document.createElement(\"script\");\n",
       "           script.type = \"text/javascript\";\n",
       "           script.src = \"https://cdn.jsdelivr.net/gh/JetBrains/lets-plot@v3.2.0/js-package/distr/lets-plot.min.js\";\n",
       "           script.onload = function() {\n",
       "               window.letsPlotCall = function(f) {f();};\n",
       "               window.letsPlotCallQueue.forEach(function(f) {f();});\n",
       "               window.letsPlotCallQueue = [];\n",
       "               \n",
       "               \n",
       "           };\n",
       "           script.onerror = function(event) {\n",
       "               window.letsPlotCall = function(f) {};\n",
       "               window.letsPlotCallQueue = [];\n",
       "               var div = document.createElement(\"div\");\n",
       "               div.style.color = 'darkred';\n",
       "               div.textContent = 'Error loading Lets-Plot JS';\n",
       "               document.getElementById(\"Q90Qfj\").appendChild(div);\n",
       "           };\n",
       "           var e = document.getElementById(\"Q90Qfj\");\n",
       "           e.appendChild(script);\n",
       "       })();\n",
       "   </script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "%use dataframe\n",
    "%use lets-plot"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "id": "6dad6349-adcc-4f3d-abcb-756d8b26f9f6",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "[untitled, player_name, team_abbreviation, age, player_height, player_weight, college, country, draft_year, draft_round, draft_number, gp, pts, reb, ast, net_rating, oreb_pct, dreb_pct, usg_pct, ts_pct, ast_pct, season]"
      ]
     },
     "execution_count": 2,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val raw_df = DataFrame.readCSV(\"../resources/example-datasets/datasets/all_seasons.csv\")\n",
    "raw_df.columnNames()"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "7401f328-ff8c-4561-9046-2d6d5f2997bf",
   "metadata": {},
   "source": [
    "As showed above, the dataset includes demographic variables like age, height, weight and place of birth, as well as biographical details such as the team they played for, draft year and round. Additionally, it contains basic box score statistics such as games played, average number of points, rebounds, assists, etc. "
   ]
  },
  {
   "cell_type": "markdown",
   "id": "5276456f-2b70-44f3-9313-b9b281060c87",
   "metadata": {},
   "source": [
    "Let's look through the data types that has been interpreted by DataFrame:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "id": "26312a99-279b-4334-937b-a6ca19b44cda",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/plain": [
       "untitled: Int\n",
       "player_name: String\n",
       "team_abbreviation: String\n",
       "age: Double\n",
       "player_height: Double\n",
       "player_weight: Double\n",
       "college: String?\n",
       "country: String\n",
       "draft_year: String\n",
       "draft_round: String\n",
       "draft_number: String\n",
       "gp: Int\n",
       "pts: Double\n",
       "reb: Double\n",
       "ast: Double\n",
       "net_rating: Double\n",
       "oreb_pct: Double\n",
       "dreb_pct: Double\n",
       "usg_pct: Double\n",
       "ts_pct: Double\n",
       "ast_pct: Double\n",
       "season: String"
      ]
     },
     "execution_count": 3,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "raw_df.schema()"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "9b1359c2-d5a1-4f02-a90d-6d0abad6341e",
   "metadata": {},
   "source": [
    "At a first sight we notice that the column `untitled` is useless, so we will remove it. We also notice that it would be more convenient to store ages as `Int` instead of `Double`. For all the columns concerning **draft**, the type is string because of Undrafted players, so we will keep the type `String` for convenience.\n",
    "\n",
    "Let's apply this chain of changes and assign the new dataframe to a new object"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "id": "2e5cd40f-4222-43fb-8585-56a02251fc0f",
   "metadata": {
    "tags": []
   },
   "outputs": [],
   "source": [
    "val df = raw_df.remove { untitled }\n",
    "    .convert { age }.toInt()"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "231ef448-aa76-4171-9e39-6bde6ecf805d",
   "metadata": {},
   "source": [
    "As the type suggests, some `college` rows are missing; we can check how many of them are missing with"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "id": "3a327771-f7b5-45d6-a98b-97c785ef23b6",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":1,\"ncol\":2,\"columns\":[\"name\",\"nulls\"],\"kotlin_dataframe\":[{\"name\":\"college\",\"nulls\":5}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410176\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 1, columnsCount = 2</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"name: String\\\">name</span>\", children: [], rightAlign: false, values: [\"college\"] }, \n",
       "{ name: \"<span title=\\\"nulls: Int\\\">nulls</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5</span></span>\"] }, \n",
       "], id: -1023410176, rootId: -1023410176, totalRows: 1 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410176) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 5,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "// check if any record are missing\n",
    "df.describe().filter { it[\"nulls\"] != 0 }.select(\"name\", \"nulls\")"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "b150aa63-cc44-44c9-b5af-de5ac7e769b7",
   "metadata": {},
   "source": [
    "## Data Analysis"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "fb87f40d-014a-4ca7-a068-064e85e8d2d3",
   "metadata": {},
   "source": [
    "### Drafts"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "d70d513f-a1f5-4c6f-b4c9-e3beadbd77fe",
   "metadata": {},
   "source": [
    "Let us analyze players drafted and undrafted for each season."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "id": "ea1958ab-04d3-4f19-8ecf-6283d3bdcc57",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":5,\"ncol\":3,\"columns\":[\"season\",\"drafted\",\"undrafted\"],\"kotlin_dataframe\":[{\"season\":1996,\"drafted\":376,\"undrafted\":65},{\"season\":1997,\"drafted\":376,\"undrafted\":63},{\"season\":1998,\"drafted\":379,\"undrafted\":60},{\"season\":1999,\"drafted\":375,\"undrafted\":63},{\"season\":2000,\"drafted\":374,\"undrafted\":67}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410175\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 5, columnsCount = 3</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"season: Int\\\">season</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1996</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1997</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1998</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1999</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2000</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"drafted: Int\\\">drafted</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">376</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">376</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">379</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">375</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">374</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"undrafted: Int\\\">undrafted</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">65</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">63</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">60</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">63</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">67</span></span>\"] }, \n",
       "], id: -1023410175, rootId: -1023410175, totalRows: 5 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410175) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 6,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val drafts = df.groupBy { season.map { it.split('-')[0] } }.aggregate {\n",
    "    count { draft_year != \"Undrafted\" } into \"drafted\"\n",
    "    count { draft_year == \"Undrafted\" } into \"undrafted\"\n",
    "}.convert { season }.toInt()\n",
    "\n",
    "drafts.head(5)"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "ebc34723-9abb-48cd-981e-b9337232bef7",
   "metadata": {},
   "source": [
    "We can visualize this difference over the years"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "id": "1df8a477-916c-49e2-ba9e-50ac42df57f2",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"GHxnGX\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"mapping\":{\n",
       "\"x\":\"season\"\n",
       "},\n",
       "\"data\":{\n",
       "\"undrafted\":[65.0,63.0,60.0,63.0,67.0,68.0,66.0,66.0,75.0,89.0,89.0,79.0,68.0,70.0,67.0,76.0,70.0,84.0,91.0,76.0,92.0,135.0,129.0,121.0,128.0,167.0],\n",
       "\"season\":[1996.0,1997.0,1998.0,1999.0,2000.0,2001.0,2002.0,2003.0,2004.0,2005.0,2006.0,2007.0,2008.0,2009.0,2010.0,2011.0,2012.0,2013.0,2014.0,2015.0,2016.0,2017.0,2018.0,2019.0,2020.0,2021.0],\n",
       "\"drafted\":[376.0,376.0,379.0,375.0,374.0,372.0,362.0,376.0,389.0,369.0,369.0,372.0,377.0,372.0,385.0,402.0,399.0,398.0,401.0,400.0,394.0,405.0,401.0,408.0,412.0,438.0]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"breaks\":[1996.0,1999.0,2002.0,2005.0,2008.0,2011.0,2014.0,2017.0,2020.0]\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"trans\":\"log10\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"y\":\"drafted\"\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"point\",\n",
       "\"data\":{\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "\"y\":\"drafted\"\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"darkgreen\",\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"line\",\n",
       "\"data\":{\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "\"y\":\"undrafted\"\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"point\",\n",
       "\"data\":{\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "\"y\":\"undrafted\"\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"orange\",\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"line\",\n",
       "\"data\":{\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"GHxnGX\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 7,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val drafted = geomPoint() { y=\"drafted\" } +\n",
    "    geomLine(color=\"darkgreen\") { y=\"drafted\" }\n",
    "    \n",
    "val undrafted =  geomPoint() { y=\"undrafted\"} +\n",
    "    geomLine(color=\"orange\") { y=\"undrafted\"}\n",
    "    \n",
    "ggplot(drafts.toMap()) { x =  \"season\" } + drafted + undrafted +\n",
    "    scaleXContinuous(breaks = (1996..2021 step 3).toList()) +\n",
    "    scaleYLog10()"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "0a4ed7d1-d057-4a0f-9023-3d95a41653ad",
   "metadata": {},
   "source": [
    "We can see that the number of drafted players are three times more than undrafted players in each season. There is an increase in the trend of undrafted players in 2017-18 season, because that was the year when the [\"two way contract\"](https://en.wikipedia.org/wiki/Two-way_contract) rule applied, which help undrafted players secure deals with NBA franchises."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "a63756b4-36a7-4385-8ef5-574af62cf52e",
   "metadata": {},
   "source": [
    "### Height and Weight"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "896926b8-fd3b-46e7-a59d-0a89cae35587",
   "metadata": {},
   "source": [
    "We can summarize player's physical data with the [Body Mass Index (BMI)](https://en.wikipedia.org/wiki/Body_mass_index) value for each player. Before of this, we must track a player changes during the years, so we will compute an average of weight and height."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "id": "9c841122-fc1c-4645-9b27-382c1c5762fa",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":6,\"ncol\":4,\"columns\":[\"player_name\",\"player_height\",\"player_weight\",\"BMI\"],\"kotlin_dataframe\":[{\"player_name\":\"Dennis Rodman\",\"player_height\":199.39,\"player_weight\":97.52228,\"BMI\":24.529974655308152},{\"player_name\":\"Dwayne Schintzius\",\"player_height\":217.17000000000002,\"player_weight\":123.60382,\"BMI\":26.207900437414363},{\"player_name\":\"Earl Cureton\",\"player_height\":205.74,\"player_weight\":95.25432,\"BMI\":22.503351819689467},{\"player_name\":\"Ed O'Bannon\",\"player_height\":203.2,\"player_weight\":100.697424,\"BMI\":24.3877061504123},{\"player_name\":\"Ed Pinckney\",\"player_height\":205.74,\"player_weight\":108.86208,\"BMI\":25.718116365359393},{\"player_name\":\"Eddie Johnson\",\"player_height\":200.66,\"player_weight\":97.52228000000001,\"BMI\":24.220451260963408}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410174\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 6, columnsCount = 4</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"player_name: String\\\">player_name</span>\", children: [], rightAlign: false, values: [\"Dennis Rodman\",\"Dwayne Schintzius\",\"Earl Cureton\",\"Ed O&#39;Bannon\",\"Ed Pinckney\",\"Eddie Johnson\"] }, \n",
       "{ name: \"<span title=\\\"player_height: Double\\\">player_height</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">199.390000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">217.170000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">205.740000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">203.200000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">205.740000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">200.660000</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"player_weight: Double\\\">player_weight</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">97.522280</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">123.603820</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">95.254320</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">100.697424</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">108.862080</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">97.522280</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"BMI: Double\\\">BMI</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">24.529975</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">26.207900</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">22.503352</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">24.387706</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">25.718116</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">24.220451</span></span>\"] }, \n",
       "], id: -1023410174, rootId: -1023410174, totalRows: 6 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410174) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 8,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val physical_data = df.select { player_name and player_height and player_weight }\n",
    "    .groupBy { player_name }.mean()\n",
    "    .add(\"BMI\") { player_weight / (Math.pow(player_height / 100, 2.0))}\n",
    "\n",
    "physical_data[0..5]"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "14177414-6740-4013-a5b2-0bee5f44cdca",
   "metadata": {},
   "source": [
    "We can then plot the distribution of height, adding the global male height average of 171 cm."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "id": "aebbf6b9-80ce-4ee3-9d08-a20d846daf7a",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"erENvZ\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Distribution of Height\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"player_height\"\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"Height (cm)\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Count\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"bin\",\n",
       "\"position\":\"stack\",\n",
       "\"binwidth\":2.0,\n",
       "\"geom\":\"histogram\",\n",
       "\"fill\":\"#00798c\",\n",
       "\"data\":{\n",
       "\"player_height\":[159.62,161.62,163.62,165.62,167.62,169.62,171.62,173.62,175.62,177.62,179.62,181.62,183.62,185.62,187.62,189.62,191.62,193.62,195.62,197.62,199.62,201.62,203.62,205.62,207.62,209.62,211.62,213.62,215.62,217.62,219.62,221.62,223.62,225.62,227.62,229.62,231.62],\n",
       "\"..count..\":[1.0,0.0,0.0,1.0,1.0,0.0,0.0,0.0,5.0,17.0,25.0,3.0,56.0,83.0,110.0,155.0,33.0,171.0,229.0,196.0,58.0,211.0,233.0,253.0,225.0,38.0,166.0,114.0,37.0,22.0,0.0,11.0,2.0,3.0,3.0,0.0,1.0]\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"#d1495b\",\n",
       "\"size\":2.0,\n",
       "\"position\":\"identity\",\n",
       "\"xintercept\":171.0,\n",
       "\"geom\":\"vline\",\n",
       "\"data\":{\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"#edae49\",\n",
       "\"size\":2.0,\n",
       "\"position\":\"identity\",\n",
       "\"xintercept\":200.1634903225323,\n",
       "\"geom\":\"vline\",\n",
       "\"data\":{\n",
       "}\n",
       "}],\n",
       "\"theme\":{\n",
       "\"title\":{\n",
       "\"hjust\":0.5,\n",
       "\"blank\":false\n",
       "}\n",
       "}\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"erENvZ\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 9,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "ggplot(physical_data.toMap()) { x=\"player_height\"} +\n",
    "    geomHistogram(binWidth = 2, fill=\"#00798c\") +\n",
    "    geomVLine(xintercept = 171, size = 2.0, color=\"#d1495b\") +\n",
    "    geomVLine(xintercept = physical_data.player_height.mean(),\n",
    "              size = 2.0, color=\"#edae49\") +\n",
    "    labs(title=\"Distribution of Height\", x=\"Height (cm)\", y=\"Count\") +\n",
    "    theme(title = elementText(hjust = 0.5))\n",
    "    "
   ]
  },
  {
   "cell_type": "markdown",
   "id": "b7c3ee87-ddb8-4d70-b4ad-b385b4edd7e3",
   "metadata": {},
   "source": [
    "Where the red line is the male average height, and the golden one is the NBA average height.\n",
    "\n",
    "It can be useful to see how's the correlation between weight and height, and we can compute it with Pearson's correlation coefficient, computed as: $$\\rho_{X,Y} = \\frac{{\\sum_{i=1}^{n} (X_i - \\overline{X})(Y_i - \\overline{Y})}}{{\\sqrt{\\sum_{i=1}^{n} (X_i - \\overline{X})^2 \\sum_{i=1}^{n} (Y_i - \\overline{Y})^2}}}$$"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 10,
   "id": "8de80ef6-56a3-47e1-bda1-c1e6a50d5179",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Correlation: 0.8210705060051193\n"
     ]
    },
    {
     "data": {
      "text/html": [
       "   <div id=\"SL3lO6\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Height and Weight Correlation\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"player_weight\",\n",
       "\"y\":\"player_height\"\n",
       "},\n",
       "\"data\":{\n",
       "\"player_height\":[199.39,217.17000000000002,205.74,203.2,205.74,200.66,198.33166666666662,213.36000000000007,192.61666666666665,182.88,182.88,213.36,195.58,190.5,210.82,210.82,213.36000000000004,185.42,200.025,190.5,203.20000000000002,210.82000000000005,190.5,210.82,200.66,213.36000000000004,198.12,190.5,190.5,203.2,185.42000000000004,193.04,205.74,210.82,208.28,207.85666666666665,208.28000000000003,200.66,193.04,200.66,205.74,210.82,203.2,208.28000000000003,203.20000000000002,203.2,177.8,195.58,200.66,203.2,205.73999999999998,198.11999999999998,218.44000000000003,195.58,213.36000000000004,185.42,210.82,210.82000000000002,187.96,195.57999999999998,208.28,195.58,208.28,208.28,203.20000000000002,203.20000000000002,187.96,198.12,203.708,200.66,197.2733333333333,203.20000000000002,193.04,200.66,206.58666666666667,195.58,193.04,193.04,210.82000000000005,208.28,190.5,209.97333333333336,203.2,208.28,190.5,193.04,203.20000000000002,190.5,203.20000000000002,203.20000000000002,213.36,198.12,231.14,202.18400000000003,205.74,200.66000000000003,205.74,208.28,185.42,215.9,210.81999999999996,193.04,198.12,218.44,213.36000000000004,205.74,188.8066666666667,203.19999999999996,186.3725,210.81999999999996,205.74,203.2,180.33999999999997,187.96,205.74,205.73999999999995,213.36,213.36,204.72400000000002,187.96,210.82000000000002,193.04,203.20000000000002,195.57999999999998,182.88,195.58,210.82,199.09692307692305,185.42,208.28,210.82,203.19999999999996,205.74,198.12000000000003,220.98,205.74,205.73999999999998,203.2,205.74,195.57999999999996,205.74,210.82,205.74,203.2,205.74000000000004,187.96,198.12,182.88000000000005,208.28000000000003,193.04,213.36,208.28,210.82,200.66000000000003,187.96,203.20000000000002,205.74,193.04,205.74,205.74,205.74,210.82,210.82,200.66,213.36000000000004,195.58,208.28000000000003,210.82,200.66,208.28,200.66000000000003,185.42,198.12,195.58,210.82,200.66,177.79999999999998,200.66000000000003,198.12,180.33999999999997,208.28,208.28,185.42000000000004,180.33999999999995,200.66,200.66000000000003,215.90000000000003,205.74,185.42000000000004,195.58,210.82000000000002,193.04,203.20000000000002,182.88,200.66000000000003,203.2,193.04,200.66000000000003,205.74,193.04,210.81999999999996,200.152,198.12,205.74,205.74,210.81999999999996,195.58,210.81999999999996,198.12,190.5,210.81999999999996,208.28,200.66,200.66000000000003,203.19999999999996,200.152,195.58,208.28000000000006,187.96,200.66,194.4511111111111,198.11999999999995,187.96,190.5,200.66,200.66,205.74,205.74,195.58,198.12,180.34,200.66,208.28,190.5,201.29500000000002,208.28,187.96,198.11999999999998,182.88,215.90000000000006,205.74,210.82,228.59999999999997,208.28,205.74,210.185,203.2,184.91199999999998,208.28,198.12,187.96,187.96,193.04,210.82000000000005,195.57999999999996,205.74,187.96,193.04,200.66000000000003,200.66,201.0,210.82000000000002,193.04,210.82,200.66000000000003,208.28,193.04,223.52,208.28000000000006,187.96,215.9,210.82,190.5,200.66000000000003,193.04,203.2,203.20000000000002,213.36,193.04,200.66000000000003,180.33999999999997,213.36000000000007,198.12,205.74,177.80000000000004,193.04,210.82,198.12,193.04,191.34666666666666,208.28000000000003,193.04,203.20000000000002,208.28000000000003,205.74,198.12,213.36000000000004,203.2,203.19999999999996,200.66,213.36,213.36,215.90000000000003,210.82,205.74,187.96,205.74,187.96,213.36,189.77428571428572,190.5,205.74,203.454,187.96,218.43999999999997,180.34,205.74,198.12,193.04,190.5,208.2800000000001,182.87999999999997,208.28,193.04,198.12,210.82,208.28,208.28,205.74,210.82,208.28000000000003,223.52,187.11333333333334,185.42,213.36,190.5,195.58,210.82000000000008,185.42,213.36,213.36000000000007,190.5,199.00899999999996,205.73999999999995,203.20000000000002,208.28,200.66000000000003,200.66,205.74,203.2,195.57999999999998,195.58,185.42,187.96,200.66,185.42,200.66,195.57999999999998,190.5,185.42000000000002,195.57999999999998,198.11999999999998,203.20000000000002,208.28,195.58,195.58,203.2,190.5,212.08999999999997,208.2800000000001,200.66,210.82000000000002,208.28,186.8714285714286,194.73333333333335,185.42000000000002,205.74,200.66,195.57999999999998,198.12,205.73999999999995,205.74,203.19999999999996,210.82,203.2,195.58,210.82000000000002,215.9,200.66,195.57999999999998,200.66,182.88,198.12,203.2,208.28,195.58,195.58,203.20000000000002,186.54888888888888,184.99666666666667,205.74,160.02,195.58,198.12,185.42000000000002,212.51333333333335,205.74,205.74,208.28000000000003,210.82000000000002,211.9085714285715,205.74,205.74,195.58,187.96,208.28,190.5,200.66,205.74,218.44,195.57999999999998,185.42,200.66,203.2,210.82000000000005,195.58,208.28,205.74,190.5,205.74,190.5,182.88,208.28,214.20666666666668,208.28,198.12,205.74,209.54999999999998,208.28,210.82,200.66,198.12,205.74,208.28,200.66,208.28,198.12,187.96,208.28,198.12,203.2,205.74,205.74,220.98,208.28,210.82,195.58,205.74,190.5,187.96,189.32769230769233,203.2,205.74,210.82000000000002,208.28000000000006,211.7557894736843,200.66,207.4333333333333,203.19999999999996,220.98,210.82,185.42000000000004,199.39,198.12,190.5,200.66000000000003,198.12,193.04,210.82,182.88,167.64,195.58,205.74,190.5,203.19999999999996,190.5,213.36,205.74,177.8,202.43800000000005,205.74,203.2,203.2,195.57999999999996,182.88,207.43333333333337,193.04,198.12,208.28000000000006,198.12,190.5,195.57999999999998,205.74,195.58,200.66,195.58,193.04,198.12,195.58,177.79999999999998,185.42000000000004,205.74,193.04,182.88,193.04,213.36,195.58,190.5,213.36,185.42000000000004,193.04,195.58,210.82,200.66,205.74,207.01,195.58,205.73999999999998,218.44000000000003,190.5,210.82,213.1785714285715,195.57999999999998,190.5,198.12,193.04,193.04,190.5,210.82,203.2,198.12,210.82,213.36,214.2066666666667,198.35090909090903,177.8,182.88000000000002,198.12,205.73999999999995,193.04,205.74,200.66,205.73999999999995,205.74,180.34,193.04,187.96,200.66000000000003,195.07200000000003,210.82,213.36000000000007,186.69000000000003,213.3600000000001,190.5,210.81999999999996,200.66,205.74,195.57999999999996,185.42,200.66,203.20000000000002,203.19999999999996,196.088,210.82,193.04,208.28000000000003,208.2800000000001,185.42,205.74,213.36,199.72421052631572,207.49846153846158,208.28,210.82,210.82,208.2800000000001,213.3600000000001,200.66,196.85000000000002,193.04,205.74,213.23904761904768,165.09999999999997,185.42000000000002,215.90000000000003,213.36,210.82,208.28,190.5,203.2,205.74,185.42000000000004,208.28,193.04,205.74,204.395294117647,210.82,205.74,190.5,203.2,193.04,203.20000000000002,195.58,193.04,203.20000000000002,187.96,187.96,210.82000000000002,195.58,193.04,204.47,195.58,190.5,195.57999999999998,220.98,188.1094117647059,187.37384615384616,208.28,180.33999999999995,198.11999999999995,187.96,208.28,210.82,205.74,200.65999999999997,190.5,195.58,200.29714285714286,205.74,195.58,204.724,190.5,200.66000000000003,187.96,190.5,218.44,200.66,213.36,218.44,210.82,208.28000000000006,207.01,195.58,203.2,212.72500000000002,203.20000000000002,201.12181818181818,187.96,205.74,200.66,187.96,200.51058823529408,203.48222222222225,190.86285714285714,205.74,195.57999999999996,198.12,203.2,210.82,182.87999999999997,185.42000000000004,203.20000000000002,195.57999999999998,215.9,205.74,195.58,195.57999999999996,205.74,213.36,210.81999999999996,215.9,207.60266666666672,210.82,185.42,218.44,205.74,205.74,200.66,200.66000000000003,210.82,218.44000000000003,210.81999999999996,210.60833333333335,185.42,210.82,213.67750000000007,200.66,196.4266666666667,215.9,203.20000000000002,213.36000000000007,204.0466666666667,208.28,213.36000000000004,205.3166666666667,195.58,205.74,187.96,203.2,190.5,203.19999999999996,198.11999999999998,215.90000000000006,208.28000000000003,189.93555555555557,213.36000000000004,177.8,190.89076923076922,205.73999999999995,208.28,203.2,210.82,208.28,182.88,206.30444444444444,200.66,200.66000000000003,195.57999999999996,197.92461538461535,193.04,208.28,193.04,208.28,205.74,187.59714285714287,207.26399999999998,210.82000000000002,195.57999999999998,215.90000000000003,210.82,213.3600000000001,198.12,195.58,186.69,200.66,193.04,208.28000000000003,217.17,205.74,210.82000000000002,208.28,195.57999999999998,201.93,187.96,187.96,205.74,210.82000000000002,213.36000000000004,205.73999999999995,185.42,208.28000000000006,208.28,215.76631578947377,203.2,213.36,205.74,200.65999999999997,215.9,210.82000000000002,212.72500000000002,180.33999999999997,203.2,200.65999999999997,208.2800000000001,190.5,187.96,213.3600000000001,203.2,205.74,205.73999999999998,210.82,205.74,205.74000000000004,213.3600000000001,195.58,208.28,198.11999999999998,180.34,193.04,190.5,182.88,198.12,193.04,198.11999999999995,213.3600000000001,210.82,191.76999999999998,207.77200000000002,185.42000000000004,211.51272727272726,192.11636363636362,200.66,208.28,213.36,198.5107692307692,200.66,218.44,198.12,200.66,205.54461538461538,203.2,189.23000000000002,208.28000000000003,200.66,208.82428571428576,195.58,182.88,205.74,200.66,210.82,187.96,187.96,205.74,196.85000000000002,187.96,210.5890909090909,185.65090909090912,210.82,187.96,190.5,195.57999999999998,208.28000000000006,191.135,210.82,199.39,193.04,203.19999999999996,200.66,203.2,210.82,195.57999999999998,200.66,228.28249999999997,203.19999999999996,205.73999999999998,193.04,203.2,207.64499999999998,198.11999999999995,208.28,200.66,190.5,193.04,198.12000000000003,208.28,199.93428571428572,215.9,210.82000000000005,213.36,210.82000000000002,208.28,198.12,203.2,210.82,208.28,178.16285714285712,205.73999999999995,203.2,203.2,198.11999999999998,185.42000000000004,195.58,185.42,205.74,200.66,203.6010526315789,200.21176470588233,195.58,191.67230769230767,190.5,208.28000000000006,198.11999999999998,198.11999999999998,187.96,210.82000000000002,203.20000000000002,187.32500000000002,203.20000000000002,210.82000000000002,205.50909090909093,198.12,203.2,203.2,182.88,185.42,200.66,210.82000000000005,187.96,190.28833333333333,203.19999999999993,200.66,195.58,198.12,182.88,190.5,226.06,200.66000000000003,195.57999999999996,200.66,213.3600000000001,209.45230769230773,202.9326315789473,205.57066666666663,213.36000000000007,205.10500000000002,198.11999999999995,213.36,190.5,208.28,205.74,200.66,203.2,208.28,203.20000000000002,202.47428571428574,203.2,203.19999999999996,200.15200000000004,203.2,205.74,195.57999999999998,193.04,200.66,205.74,213.36000000000007,208.28000000000003,203.2,190.5,175.26,190.5,200.66,204.81636363636363,210.39666666666673,191.4525,200.66,193.04,205.74,203.19999999999993,193.04,182.88000000000002,182.88,198.12,190.5,190.5,198.12,195.58,182.88,208.28000000000006,210.09428571428575,177.8,195.58,198.11999999999995,200.66000000000003,211.836,205.74,213.36000000000007,198.11999999999998,213.36,198.12,185.42000000000002,203.19999999999996,205.73999999999998,203.20000000000002,213.36,182.88,205.73999999999998,198.12,200.66,208.28,208.28,198.11999999999995,198.12,185.42,220.98,182.88000000000005,204.47,210.82,187.96,210.82000000000002,198.12000000000003,220.98,226.06,208.28,200.66,192.53199999999998,214.63,200.66000000000003,207.9171428571429,207.01,208.28000000000006,198.12,214.63,205.57066666666663,187.96,213.36000000000007,195.58,208.28,208.28,200.66000000000003,190.5,205.74,190.5,190.5,213.36000000000007,200.66,201.93,195.58,209.804,202.35333333333335,203.2,200.66000000000003,200.66,213.36000000000007,180.33999999999997,190.5,205.74,204.47,205.74,190.5,187.96,200.66,193.04,213.36,198.12,195.58,193.04,205.73999999999998,210.81999999999996,193.04,213.3600000000001,213.36000000000007,190.5,203.20000000000002,198.11999999999998,190.5,204.21600000000004,208.28,183.02941176470594,198.11999999999995,211.01538461538465,210.82,187.96,208.28000000000003,200.66000000000003,185.42,193.04,205.74,203.2,205.74,208.28,205.74,193.04,200.66,185.42000000000004,208.28,195.58,205.74,182.88,205.74,185.42,198.12,185.42,205.74,203.20000000000002,185.86823529411768,215.9,190.5,190.5,205.74,200.66,190.5,190.5,175.26,205.74,200.66000000000003,218.44,205.57066666666663,198.12,195.58,193.04,208.28,208.28,200.66,193.04,210.81999999999996,200.66,182.51714285714291,192.70133333333334,208.28,208.28,195.58,205.74,187.96,200.66,187.96,198.12,187.96,201.08333333333334,208.28,207.69384615384612,195.58,185.42000000000004,210.82,193.04,203.20000000000002,190.5,197.6966666666667,213.36,210.82,202.72374999999997,206.375,200.66,190.5,192.75777777777776,206.10285714285715,205.74,187.96,200.66,198.12,200.66000000000003,203.35874999999996,213.36000000000007,205.74,187.96,203.2,208.28,183.03875000000005,210.82000000000005,203.2,193.88666666666666,200.66,203.2,215.9,210.82000000000002,198.12,195.58,195.58,200.47857142857143,198.12,208.28000000000003,203.19999999999996,205.74,200.66,187.96,182.88,205.74,193.04,208.28,207.01,187.96,208.28,198.12,198.12,205.74,200.66,205.74,213.36000000000007,215.9,205.74,187.96,195.58,210.82,203.2,195.58,203.2,200.29714285714286,193.04,187.96,210.82000000000002,205.74,195.57999999999996,187.96,182.88000000000002,213.36000000000007,190.5,207.772,203.2,198.12,215.9,205.74,195.58,205.73999999999998,210.82,208.02599999999998,187.96,205.74,213.3600000000001,210.82,200.025,213.36,185.42000000000004,198.12,198.12,208.28,190.5,195.57999999999998,208.28000000000003,190.5,203.2,200.66,193.04,206.10285714285718,195.58,205.19571428571427,208.28,210.82000000000002,205.74,211.03166666666667,195.57999999999996,195.58,218.44,215.9,210.82,205.74,182.88,203.19999999999996,195.58,213.36000000000004,203.62333333333333,215.39200000000005,203.2,182.88,208.06833333333338,190.5,198.12,208.28,213.3600000000001,205.74,195.58,218.44,198.12,205.74,213.36,191.5885714285714,189.9557142857143,190.68142857142857,213.36,205.74,198.12,195.58,187.96,218.44000000000003,207.58727272727273,187.39555555555557,208.28000000000003,195.58,193.67499999999998,203.3814285714286,203.2,213.3600000000001,205.74,203.83499999999998,195.58,210.81999999999996,205.74,190.5,203.2,203.20000000000002,198.12,215.11846153846162,207.19142857142856,213.3600000000001,198.12,208.28000000000006,205.74,182.33571428571435,195.57999999999996,200.66,205.74,210.82,195.58,205.74,210.82000000000002,193.04,189.91384615384615,200.66000000000003,195.57999999999998,209.97333333333333,216.98857142857148,203.5907692307692,213.3600000000001,198.12,187.96,186.69000000000003,210.82,195.58,205.74,187.96,183.27076923076928,205.74,187.6425,180.33999999999997,205.74,194.99384615384614,193.43076923076922,198.11999999999998,198.12,200.66,208.67076923076928,198.12,205.73999999999998,185.42,190.30461538461537,198.11999999999995,183.3418181818182,210.82,203.20000000000002,203.2,187.96,200.66000000000003,208.28,190.5,200.07384615384615,202.73818181818186,203.19999999999996,213.36000000000004,185.42000000000002,200.66000000000003,190.5,198.12,210.81999999999996,198.12,200.66,208.28,182.88,208.28,192.45384615384611,193.04,200.66,190.5,195.57999999999996,204.17692307692306,220.97999999999996,197.48499999999999,195.2625,188.38333333333335,193.04,205.74,193.04,190.5,195.58,203.56285714285715,198.12,208.28,210.81999999999996,207.64499999999998,200.66,210.82,205.74,210.35818181818183,205.74,207.64499999999998,190.5,215.90000000000003,210.81999999999996,203.20000000000002,190.5,198.12,193.04,200.66000000000003,215.9,193.04,190.5,188.59500000000003,212.09,205.74,205.27818181818182,180.34,207.19142857142856,196.08799999999997,200.66,205.74,190.5,192.786,193.88666666666666,200.66,210.81999999999996,198.12,191.76999999999998,201.0,205.74,200.66,195.58,210.82,207.64499999999998,208.28,185.42000000000004,200.40600000000003,205.74,210.82,200.66,193.04,199.20857142857145,180.34,204.47,205.27818181818182,200.66,213.36000000000007,210.81999999999996,202.56500000000003,210.56599999999997,198.12,198.12000000000003,213.36,213.36000000000007,182.88000000000002,208.28,210.82,208.28000000000003,208.28,203.2,175.26,195.57999999999998,177.8,189.93555555555557,198.12,204.04666666666665,190.5,206.86888888888888,198.11999999999998,190.5,205.0472727272727,190.5,192.53199999999998,203.20000000000002,200.66,205.74,210.31199999999998,196.0,198.12,205.74,195.58,180.34,190.5,195.58,208.28,198.12,193.04,200.66,190.0381818181818,192.11636363636362,203.2,210.82,198.12,187.96,187.96,212.4363636363637,193.04,208.28,205.97090909090912,208.28,195.58,182.88,190.5,204.35454545454547,193.04,203.2,208.28,200.66,208.28,208.28,187.96,198.12,180.34,208.28,201.12181818181818,187.96,211.66666666666666,187.96,213.36,190.5,208.28,200.66000000000003,187.96,213.36,210.82,195.58,205.74,195.58,205.74,207.35636363636365,200.3777777777778,184.72727272727278,203.20000000000002,205.74,203.20000000000002,189.80727272727273,185.42,210.82000000000002,200.66000000000003,205.74,213.36,199.38999999999996,197.358,180.34,212.09,205.74,210.82,208.28000000000003,210.82,205.74,198.12,213.04250000000005,190.5,205.74,200.66,207.9625,203.20000000000002,198.12,198.12,193.04,194.81799999999998,203.2,198.12,201.93000000000004,210.82,202.63555555555558,210.81999999999996,205.74,195.58,195.58,190.5,185.42000000000002,185.42,187.96,203.96200000000005,215.3355555555556,200.34250000000003,210.18499999999997,199.898,213.36,210.82000000000002,203.2,192.7225,213.36000000000004,193.04,199.898,193.04,193.04,205.74,205.74,200.66,195.57999999999998,193.04,203.20000000000002,208.28,198.11999999999998,208.28,208.28,192.786,190.5,208.28,194.31,185.42,208.53400000000002,198.12,209.55,205.74,189.738,187.96,202.35333333333332,203.83499999999998,208.28,203.20000000000002,208.28,193.88666666666666,199.8133333333333,190.5,180.34,182.88,210.82,198.12,195.58,185.98444444444445,200.66,177.8,195.58,187.96,212.79555555555558,191.34666666666666,204.0466666666667,193.04,193.88666666666666,210.82,184.57333333333338,195.58,199.8133333333333,200.66,193.04,200.66000000000003,203.2,195.58,205.74,198.12,187.96,200.66,200.66,210.82,203.2,215.90000000000003,200.66,180.34,197.2733333333333,212.51333333333335,199.8133333333333,204.47,200.66,203.2,210.81999999999996,195.58,213.36,212.51333333333335,195.57999999999998,190.5,213.36000000000004,192.405,190.5,210.25555555555553,203.2,209.9733333333333,208.28,213.36000000000007,195.58,203.2,190.5,198.12,190.5,193.04,213.36,209.9733333333333,197.48499999999999,203.2,190.5,182.88,213.36,195.58,200.66,197.75714285714284,215.0533333333334,195.58,204.78750000000002,212.40749999999997,198.12,185.42,203.0,198.12,205.74,202.88250000000002,210.82,187.00750000000002,187.96,213.36,203.2,205.74,190.5,199.20857142857145,208.28,192.08749999999998,198.96666666666667,208.28,193.04,208.28,193.04,205.74,198.12,204.1525,205.74,204.04666666666665,204.47000000000003,195.58,202.88250000000002,207.01,199.70749999999998,190.5,210.82,226.06,197.485,203.19999999999996,207.01,182.88,184.99666666666667,193.04,184.46750000000003,183.0,195.89749999999998,195.58,208.28,190.5,191.76999999999998,203.20000000000002,208.28,210.50249999999997,190.5,192.40499999999997,198.12,208.28000000000003,206.82857142857142,198.12,196.0,194.6275,202.56500000000003,205.74,185.42,195.58,205.74,204.78750000000002,208.28,195.58,202.24750000000003,213.36,180.34,208.28,198.12,202.24750000000003,205.74,209.86749999999998,203.2,208.28,197.27333333333334,207.4333333333333,205.74,203.2,190.5,207.91714285714286,191.95142857142855,210.45714285714283,210.81999999999996,202.11142857142858,200.66,200.29714285714286,185.42,212.27142857142854,199.57142857142858,197.27333333333334,197.03142857142856,200.66,205.74,203.56285714285715,195.58,220.98,220.98,198.755,186.50857142857143,186.8714285714286,199.57142857142858,191.76999999999998,209.97333333333336,213.36000000000007,185.78285714285715,207.1914285714286,185.78285714285715,198.12,205.74,195.58,195.21714285714285,208.28,210.82,205.23200000000003,218.44,199.81333333333336,203.19999999999996,193.88666666666668,213.36000000000007,195.57999999999998,197.03142857142856,205.74,220.98,208.28,200.66,193.04,187.96,200.66,209.97333333333333,200.66,200.66,221.7057142857143,209.73142857142855,198.12,198.12,203.2,208.28,195.58,208.70333333333335,203.2,200.66,207.85666666666665,203.2,198.12,194.49142857142857,207.4333333333333,198.12,187.96,198.12,188.32285714285715,177.80000000000004,200.66,193.04,196.21500000000003,200.66,199.39,194.945,187.96,182.88,210.81999999999996,198.12,190.5,193.04,193.04,214.88400000000001,201.50666666666666,213.36,210.185,198.12,205.74,205.74,196.85000000000002,207.01000000000002,213.36,205.74,200.66,194.30999999999997,208.28,198.12,195.58,190.5,213.36,213.36,175.26,205.74,203.2,193.04,203.19999999999996,205.3166666666667,200.66,210.82,212.09,208.28000000000003,208.28,204.72400000000002,187.96,210.82,209.97333333333336,198.9666666666667,195.07199999999997,185.42,194.05599999999998,196.85000000000002,208.28,194.31000000000003,210.39666666666665,199.39000000000001,198.12,204.04666666666665,198.12,205.74,193.04,189.23000000000002,208.28,204.04666666666665,199.39000000000001,205.74,186.944,177.8,203.2,200.66,198.12,213.36000000000004,205.74,201.92999999999998,192.53199999999998,214.63000000000002,215.9,201.08333333333334,190.5,184.14999999999998,215.26500000000001,204.47000000000003,214.63000000000002,193.04,190.5,209.804,191.76999999999998,199.39000000000001,187.45199999999997,199.64399999999998,203.2,193.04,183.72666666666666,188.97600000000003,193.04,200.66,194.564,180.34,203.2,194.945,206.756,195.58,201.676,204.89333333333335,195.58,193.04,190.5,196.4266666666667,204.21599999999998,200.66,196.08800000000002,196.59600000000003,213.36,208.28000000000003,199.13600000000002,209.12666666666667,203.2,210.31199999999998,200.66,205.74,200.66,203.2,200.66,198.12,208.91500000000002,203.2,206.58666666666667,195.58,206.756,203.2,195.58,182.88,206.756,203.2,185.42,198.12,208.28,205.74,208.28,190.5,196.59600000000003,196.85000000000002,193.04,209.97333333333333,200.66,190.5,201.676,195.072,205.74,203.70800000000003,195.58,207.01,195.58,205.74,193.04,199.13600000000002,190.5,203.2,195.58,199.39000000000001,208.28,203.2,196.59600000000003,200.152,208.28000000000003,208.788,212.08999999999997,204.21600000000004,182.88,192.02399999999997,208.28,198.12,195.58,217.42400000000004,200.66,190.5,198.12,192.1933333333333,200.66,215.9,188.97600000000003,193.04,208.28,195.58,209.296,195.58,194.31,185.42,203.2,202.692,195.58,212.852,184.14999999999998,212.08999999999997,205.74,193.04,198.12,205.74,188.80666666666664,187.96,196.59600000000003,195.58,198.12,205.74,196.088,199.13600000000002,190.5,201.676,195.57999999999998,193.04,195.58,201.295,205.74,205.10500000000002,207.01,195.58,196.21500000000003,197.485,199.39,193.04,203.2,205.10500000000002,208.28,191.135,205.74,194.31,202.565,207.64499999999998,187.96,186.05499999999998,213.36,196.21500000000003,193.04,203.2,208.28,198.755,205.74,190.5,205.74,190.5,191.76999999999998,206.375,186.05499999999998,193.04,203.2,201.295,196.85,203.2,213.36,190.5,213.36,194.31,209.97333333333336,195.58,199.39000000000001,196.21500000000003,198.12,193.67499999999998,194.31,201.93,199.39000000000001,206.375,193.67499999999998,180.97500000000002,199.81333333333336,198.12,198.12,191.135,184.15,195.58,189.23000000000002,189.23000000000002,198.12,212.08999999999997,200.66,186.05499999999998,193.04,194.31,200.66,200.66,193.67499999999998,190.5,208.28,210.82,204.47,213.36,213.995,198.12,210.82,201.92999999999998,196.4266666666667,198.755,199.39,200.66,185.42000000000002,195.58,193.88666666666666,186.05499999999998,191.76999999999998,205.74,195.57999999999998,186.68999999999997,190.5,210.82,203.2,203.2,203.83499999999998,198.755,193.04,205.74,205.74,193.04,193.04,183.515,191.76999999999998,195.58,192.1933333333333,187.96,195.58,208.28,198.12,195.58,190.5,205.74,187.96,205.74,210.82,196.4266666666667,205.74,195.58,190.5,218.43999999999997,195.58,208.28,190.5,208.28,190.5,187.96,196.42666666666665,195.58,203.19999999999996,200.66,182.88,185.42,200.66,198.12,193.04,205.74,200.66,185.42,208.28,185.42,193.04,208.28,177.80000000000004,193.04,195.58,195.58,208.28,203.19999999999996,195.58,199.39,195.58,203.2,205.74,203.19999999999996,213.36,200.66,195.58,193.04,226.90666666666667,190.5,198.12,190.5,198.12,200.66,200.66,193.88666666666666,208.28,198.12,182.88,204.04666666666665,203.19999999999996,207.4333333333333,195.58,196.42666666666665,193.88666666666666,203.19999999999996,175.26,185.42,208.28,201.50666666666666,195.58,205.74,202.35333333333332,203.19999999999996,198.12,217.17000000000002,200.66,208.28,195.58,194.31,180.34,203.19999999999996,203.19999999999996,195.58,205.74,198.12,203.19999999999996,218.43999999999997,210.82000000000002,193.88666666666666,198.12,195.58,177.80000000000004,206.58666666666667,193.04,190.5,203.19999999999996,193.04,180.34,189.23000000000002,195.58,187.96,193.04,198.12,208.28,207.01,203.19999999999996,198.12,198.12,190.5,195.58,211.66666666666666,185.42,205.74,199.39,195.58,185.42,198.12,199.39,205.74,177.8,193.04,210.82,213.36,195.58,203.2,195.58,193.04,196.85000000000002,190.5,205.74,200.66,198.12,193.04,185.42,193.04,208.28,203.2,205.74,205.74,190.5,200.66,193.04,187.96,195.58,210.82,200.66,205.74,203.2,205.74,195.58,208.28,213.36,185.42,187.96,203.2,187.96,200.66,193.04,198.12,193.04,200.66,198.12,203.2,187.96,198.12,185.42,195.58,203.2,198.12,203.2,193.04,189.23000000000002,193.04,208.28,213.36,195.58,200.66,198.12,195.58,190.5,190.5,203.2,187.96,198.12,190.5,195.58,208.28,195.58,190.5,193.04,203.2,193.04,205.74,195.58,186.69,195.58,187.96,195.58,205.74,203.2,205.74,177.8,195.58,195.58,198.12,200.66,193.04,190.5,200.66,187.96,200.66,190.5,208.28,203.2,210.82,198.12,208.28,208.28,187.96,215.9,193.04,208.28,195.58,190.5,215.9,193.04,198.12,210.82,205.74,203.2,190.5,193.04,205.74,195.58,205.74,198.12,193.04,205.74,193.04,195.58,203.2,193.04,208.28,203.2,198.12,187.96,182.88,200.66,190.5,198.12,213.36,203.2,187.96,195.58,193.04,195.58,193.04,195.58,208.28,208.28,205.74,182.88,193.04,193.04,195.58,195.58,195.58,205.74,185.42,200.66,193.04,190.5,198.12,200.66,210.82,205.74,200.66,200.66,195.58,185.42,190.5,205.74,203.2,198.12,195.58,193.04,193.04,210.82,210.82,198.12,190.5,203.2,198.12,203.2,195.58,182.88,203.2,187.96,195.58,203.2,195.58,203.2,195.58,203.2,213.36,185.42,200.66,193.04,198.12,185.42,193.04,203.2,190.5,182.88,198.12,190.5,180.34,208.28,198.12,198.12,203.2,195.58,185.42,187.96,210.82,213.36,198.12,187.96,195.58,208.28,180.34,200.66,210.82,195.58,208.28],\n",
       "\"player_weight\":[97.52228,123.60382,95.25432,100.697424,108.86208,97.52228000000001,90.491604,121.26026133333332,86.33367733333334,69.399576,77.11064,122.46983999999999,88.37484133333334,80.28578399999998,120.20188,106.59411999999999,122.46983999999999,87.31645999999999,97.59787866666666,92.53276800000002,99.79024000000003,120.20188000000003,96.06070577777778,112.944408,97.52228000000001,112.94440800000002,94.347136,86.18248000000001,92.98635999999999,104.552956,93.13755733333333,93.439952,108.86208000000002,102.0582,120.95786666666666,104.17496266666667,106.59412,108.86208,83.91452,106.59411999999999,116.02883360000001,102.0582,104.32616,106.59412,113.39800000000001,98.88305600000001,72.57472,88.904032,104.32616,116.119552,105.37291076923076,92.98635999999999,118.7364289230769,92.98635999999999,123.22582666666669,83.91452,129.27372,111.13004,81.96407440000002,83.007336,123.830616,97.52228000000001,111.13004,109.315672,97.35733745454546,111.35683600000002,81.64656,81.64656,115.66596000000001,86.18248,96.76629333333335,116.119552,95.5745025882353,102.0582,109.61806666666666,95.25432,86.18248,83.41969236363637,111.15523955555557,111.13004,89.81121599999999,115.21236800000001,99.79024,98.88305600000001,83.91452,82.8836290909091,113.39800000000001,86.18248,104.47735733333333,102.0582,116.57314399999998,96.01030666666666,137.438376,98.88305600000001,108.86208,105.58613777777776,112.23162057142858,113.398,81.64656000000001,120.20188,112.10202285714286,80.739376,98.27826666666668,127.00576000000001,115.66596000000003,102.0582,81.64656,102.05819999999997,84.935102,113.39800000000001,104.32616,104.32616,81.93005500000001,82.78053999999999,109.42907000000001,108.86208000000005,115.09897000000001,118.387512,101.151016,82.553744,117.93392,99.33664800000001,97.52228000000002,90.71839999999999,74.84268,100.017036,104.32616,92.6025513846154,83.91452,113.398,104.32616,99.79024,115.03093119999998,90.71839999999999,132.448864,117.93392,107.89009714285714,95.82131,102.0582,94.80072800000002,105.27114333333333,108.86208,105.3240624,120.20188,107.83118909090909,89.811216,90.97039555555554,75.81466285714285,118.38751200000002,87.543256,111.13004,110.6260488888889,120.76886999999999,97.52228000000001,82.55374399999998,116.04395333333333,115.66596000000003,94.34713599999999,115.66596,110.336254,105.68693599999999,106.59412,108.86207999999999,90.71839999999999,126.09857600000001,94.64953066666665,104.73851636363638,107.7281,100.697424,109.769264,111.13004,86.18248,81.64656,96.615096,110.67644800000002,95.25432,77.90442599999999,118.68990666666666,100.243832,74.19469142857143,106.59411999999999,108.08449371428571,81.64656000000001,77.11064,92.98635999999999,104.89314999999999,112.42601714285716,108.86208,92.07917599999998,84.2773936,117.93392,83.46092800000001,98.27826666666668,78.81161,102.05819999999999,102.0582,92.98635999999999,97.74907600000002,102.0582,83.91452000000001,102.511792,97.52228,114.30518400000001,97.52228000000001,111.30013699999999,111.13004,92.68396533333333,108.86208,99.79024,88.45043999999999,115.3419657142857,102.81418666666667,99.79024,98.49426285714286,102.20939733333334,96.16150400000001,90.7184,111.13004,85.17449777777779,104.32616,93.8431448888889,98.88305600000004,88.45044,83.91452000000001,99.79024,97.52228000000001,117.48032800000001,115.34844559999999,90.7184,90.7184,74.84268,99.60880320000001,109.61806666666666,94.34713599999999,103.41897600000001,118.50090999999998,83.91452,95.3903976,81.64656,145.90542666666667,107.53910333333333,117.93392,119.7986871111111,123.89541485714287,93.439952,113.398,98.42946399999998,87.089664,106.59411999999999,97.79443520000001,85.275296,86.37687657142858,94.88319927272728,103.57017333333334,92.98635999999995,101.604608,84.821704,88.45044,86.78726933333331,112.64201333333335,86.0,114.758776,87.31645999999999,111.13004,109.372371,117.93392,97.52228000000001,120.20188,105.30894266666668,86.18248,110.676448,113.398,83.91452,116.4219466666667,86.74947,109.315672,94.34713599999999,131.54168,90.7184,103.532374,82.85613866666667,106.59411999999999,100.697424,113.11450500000001,71.06274666666667,84.368112,112.26402,100.92421999999999,88.45044,86.93846666666666,128.44900727272727,93.89354399999999,104.32615999999999,105.00654799999998,117.93392,89.71041777777776,108.86208000000002,90.7184,95.25432,95.934708,120.20188,112.490816,117.93391999999997,113.398,113.39800000000001,86.13712079999999,106.59412,87.57814769230768,111.13004,81.77615771428573,85.45169288888889,113.398,100.7427832,94.34713599999999,117.93392,79.00060666666667,109.99605999999999,86.18248,86.18248,90.71839999999999,104.77975199999999,88.45043999999999,111.13004,92.98635999999999,85.275296,115.66596000000001,99.79024,110.37405333333335,101.151016,106.18588719999998,109.76926399999999,151.499728,86.93846666666667,81.64656,136.0776,92.23037333333333,95.25432,106.68483839999996,86.18248,104.779752,111.13003999999998,90.7184,95.45843639999995,105.79366352941177,108.86208,111.13004,106.94691377777778,111.67435040000001,99.79024,104.32616,87.19046222222221,85.04849999999999,80.43698133333334,88.61243714285715,95.25432,85.42649333333333,92.98635999999999,81.75995800000001,77.11064,76.203456,97.87507377777777,99.56344400000002,114.702077,120.20188,95.25432,92.98635999999999,106.59411999999999,88.45044,119.29469600000002,102.05819999999997,95.25432,108.86208,117.93392,85.66408914285715,84.29251333333333,79.3786,102.05820000000001,94.12034,95.027524,103.418976,112.03722399999997,116.289649,100.243832,113.398,97.52228000000001,90.7184,111.1998233846154,115.03093120000001,99.79024,97.82467466666668,100.11423428571426,80.73937600000001,97.975872,106.14052799999999,117.93392,98.65626000000002,97.3408432,102.05820000000001,82.85613866666668,83.53652666666666,108.86207999999999,63.502880000000005,92.98636,101.68020666666666,86.54535359999997,113.39800000000001,144.242256,106.59411999999999,111.76506880000002,108.59748466666669,113.39800000000002,95.25432,95.25432,97.52228000000001,83.91452,109.42907000000001,89.50882133333333,102.0582,107.954896,124.19348959999999,92.98635999999999,73.481904,114.79366769230772,90.7184,104.1927505882353,97.97587200000001,120.20188,112.10202285714286,83.91452,99.79024,86.74946999999999,81.64656,99.79024000000001,111.65923066666666,109.769264,102.0582,106.59411999999999,106.367324,105.08214666666667,106.59411999999999,94.68733,106.59411999999999,117.93392,106.59411999999999,106.59411999999999,105.23334399999999,81.64656,79.3786,104.32615999999999,102.511792,108.40848799999999,99.79024,120.20188,96.161504,111.63403111111113,120.20187999999999,104.779752,104.32615999999999,81.64656,83.007336,88.45043999999999,88.45044,110.903244,108.86208000000003,107.46641230769234,116.28666484210525,97.52228000000001,112.64201333333334,97.67347733333334,117.93391999999996,111.13004000000001,78.43018036363637,105.46014,101.30221333333334,84.82170399999998,95.53781500000001,102.0582,86.43447555555554,120.73794327272729,80.96617199999999,60.327736,95.25432,92.98635999999999,90.7184,107.501304,92.47940423529411,112.94440800000001,106.59411999999999,70.760352,117.93391999999997,104.32616,99.79024,99.79024,88.45043999999997,74.84268,108.10609333333333,92.4629846153846,97.01828888888889,118.87890333333331,90.7184,87.22923076923077,84.9225022222222,105.46014,104.32616,101.151016,94.800728,95.25432,110.676448,94.68733,77.18623866666667,83.91452000000001,101.49121,90.7184,76.657048,86.18248,111.13004,86.636072,95.25432,119.74828799999999,86.18247999999998,88.904032,99.79024,108.86208,102.0582,115.212368,112.037224,99.79024,117.93392000000001,108.66768342857144,83.68772400000002,117.93392,118.03111828571431,95.3903976,81.64656,91.85237999999998,95.25432,94.0172509090909,85.15158909090907,111.13004,97.52228000000001,96.615096,112.037224,124.7378,109.92046133333334,99.99641818181819,74.84268,80.12084145454546,106.59412,112.49081599999998,106.59411999999999,107.95489599999999,92.98635999999999,104.4679075,107.7281,77.11064,83.91452,84.368112,104.44986690909094,86.18248,118.841104,123.42742311111111,86.83046857142857,102.37222523076922,91.625584,100.09263466666665,96.615096,105.83813333333332,83.67027815384616,79.3786,90.30260733333331,129.1441222857143,100.09263466666665,101.69532640000001,97.52228000000001,98.12706933333334,113.398,112.16322177777775,79.3786,107.95489599999999,111.13004,105.04235789473682,103.872568,117.93392,110.44965199999999,97.52228000000001,101.06596750000001,114.15398666666668,90.7184,88.45044,95.25432,107.35010666666666,110.61164914285713,60.7464363076923,91.17199200000002,126.90496177777777,114.758776,111.13004,111.69703,86.18248,105.68693600000002,131.54168,84.29251333333335,102.965384,80.73937600000001,94.347136,116.89332658823527,115.66596000000001,111.13004,81.64656,104.32616,83.57432600000001,104.73851636363635,102.96538400000001,86.18248,97.97587200000002,83.91452,81.64656000000001,111.583632,92.532768,95.027524,119.97508400000001,88.45044,98.25500553846153,102.0582,112.26401999999999,90.93185505882352,87.92706461538461,122.46983999999999,77.72917454545455,101.89620285714282,86.18248,112.33961866666665,108.22705120000003,108.86208,101.63295749999999,90.51680355555555,86.18248,87.02486514285715,106.59411999999999,86.81750880000001,99.60880320000001,86.18248,110.0867784,86.18248,89.05522933333333,149.68536,96.161504,121.33586000000003,122.46983999999999,115.66596000000001,102.54419142857144,127.459352,92.532768,99.79024,97.80577499999998,99.563444,112.36710909090908,86.78726933333333,121.33585999999998,97.52228000000001,78.55388727272727,115.31909552941174,112.28921955555556,90.39440571428572,97.975872,88.11024599999999,99.336648,99.79024,122.46983999999999,85.728888,80.61566909090908,105.95153133333332,100.37990959999999,116.573144,96.35590057142858,90.7184,97.2082547692308,92.92156114285714,122.46983999999999,114.15398666666665,116.3917072,99.79024000000003,112.037224,80.28578399999998,138.799152,112.33961866666668,111.13004,96.16150400000001,99.22325000000001,112.26401999999999,130.89369142857146,113.64999555555556,118.12291666666668,81.64656,99.79024,120.20187999999999,98.88305600000001,92.98635999999999,126.55216800000001,110.37405333333335,112.3900177777778,118.23631466666666,118.06351771428571,115.66596000000001,108.40848799999999,96.01030666666668,110.52525066666668,94.12034,88.45044,81.64656,98.45614588235297,97.635678,113.9213753846154,108.04561439999998,82.75534044444444,117.93391999999999,90.7184,88.10152307692306,106.92675413333335,99.79024,98.85065657142857,105.233344,113.91639085714287,79.3786,102.5621911111111,97.52228000000001,99.00676290909092,95.02752400000001,104.39594338461535,95.25432,111.13004000000001,88.45044,123.60381999999998,111.13004,85.34009485714287,104.23544159999999,131.54168,99.79024000000001,114.13508700000003,123.150228,111.7348293333333,95.25432,90.7184,78.47141599999999,100.697424,87.996848,115.66596000000001,115.892756,109.769264,118.68990666666666,106.59411999999999,97.06868800000001,98.883056,82.55374400000001,85.728888,100.243832,111.13004,118.0246384,116.43973458823525,83.91452,106.367324,120.20188,107.54905052631584,99.79024,114.758776,105.233344,103.47233976470588,117.93392,113.57245846153845,106.820916,76.59224914285714,100.13915692307692,107.47610444444449,105.0519072,90.71839999999999,91.52478577777778,129.27372,91.625584,102.0582,102.23265846153845,120.20188,126.24977333333334,107.21265454545454,119.85296307692307,84.368112,99.336648,105.2787032,79.3786,95.25432,86.67730763636365,83.91452,90.7184,90.71840000000002,101.70928307692306,116.36379384615387,113.39800000000002,84.02791800000001,104.68903359999999,87.1245556923077,130.51078909090907,93.35748072727273,98.81825714285716,117.93391999999997,110.676448,94.20756923076925,94.34713599999999,108.86208,97.52228000000001,102.34979485714284,120.02742153846154,100.92422,90.7184,105.76940727272726,111.13004,111.84282742857144,90.7184,84.67050666666667,100.243832,95.25432,109.54246800000001,83.91452,83.46092800000001,122.46983999999999,97.37108266666667,88.45044,107.62501090909092,81.23420363636366,106.59412,100.04943542857141,95.10312266666666,99.79024,111.97242514285712,88.90403199999999,113.398,99.79024,82.553744,106.59411999999999,94.73094461538459,111.13004,113.398,93.8028256,95.25432,139.81973399999998,98.27826666666668,97.42508171428571,86.18248,117.93392,102.62519,93.26985499999995,104.32616,92.98635999999999,74.51868571428572,86.18248,97.52228000000001,108.86208,98.5590617142857,111.13004,115.15900423529408,102.0582,113.39799999999998,104.32616,102.0582,100.130434,116.70922160000002,118.28671377777778,81.9705542857143,104.05400480000002,102.0582,121.33585999999998,97.29548400000002,86.70585538461538,95.25432,86.18248,89.58442,102.77098742857143,112.44306947368418,95.9747308235294,99.79024,86.18247999999997,87.86725028571428,124.54340342857142,96.16150400000002,90.71839999999999,92.249273,119.44589333333333,106.32196479999998,78.471416,96.01030666666666,104.32616,95.33679127272727,92.98635999999999,111.13004,102.0582,74.84267999999999,81.64656,89.96241333333334,123.03682999999998,86.18248,91.28539,106.25989431578945,94.800728,94.347136,92.98635999999999,75.97666000000001,78.017824,124.7378,102.2396368,97.52228000000001,111.13004,120.3065550769231,104.84953538461536,105.7346825263158,110.25309546666662,120.655472,111.583632,97.87119692307691,109.315672,88.45044,95.25432,112.59161422222223,119.294696,106.43212285714283,108.86208,97.32068355555558,101.86380342857144,98.52666228571431,97.52228000000001,95.25432,107.95489599999999,107.501304,99.46624571428572,98.65626000000002,95.25432,108.86208,107.35010666666666,115.25772720000002,97.068688,90.7184,74.84268,85.06361973333333,97.52228000000001,93.81107272727273,120.07588222222223,81.64656000000001,83.78492228571429,96.615096,97.06868800000001,96.26230222222219,86.18248,76.657048,88.45044,102.0582,90.92457818181816,92.49787630769228,95.25432,99.48784533333333,81.64656,125.54778571428571,116.31394857142855,78.471416,104.32616,95.50631555555553,102.0582,109.4971088,124.7378,114.36998285714287,101.6953264,127.00576000000001,104.32615999999999,84.92250222222222,108.86208,104.32615999999997,95.197621,124.7378,81.64656,106.59411999999999,102.0582,85.61549000000001,99.79024,116.42194666666667,100.4989775,90.7184,81.64656,138.34556,86.18247999999997,108.86207999999999,115.66596000000001,88.45044,125.49378666666667,87.54325600000001,124.7378,117.93392,113.39799999999998,97.52228000000001,94.800728,113.96498999999999,90.62768159999999,115.66596000000003,112.94440800000001,107.7281,97.52228000000001,117.93392,100.30431093333337,90.7184,110.15805714285715,97.52228000000001,111.13004,122.01624799999999,89.35762399999999,85.275296,113.398,93.36435333333334,88.45044,113.96499000000001,96.16150400000001,89.58442,85.275296,113.7608736,92.60836666666667,102.965384,117.93391999999997,102.43619333333334,112.03722400000001,75.863262,90.05545784615384,99.10985199999999,114.53198000000002,110.48745133333334,83.91452,82.85613866666667,97.14428666666669,97.068688,92.98635999999999,99.79024000000001,83.91452,88.45044,100.11423428571432,114.25478488888886,90.7184,116.96193714285711,128.13974000000002,93.213156,112.26402,109.769264,83.91452,103.14682080000003,118.38751200000002,79.3786,101.434511,113.18864984615387,105.89311418181818,85.61548999999998,112.35473840000002,111.980525,79.98338933333334,89.357624,120.655472,99.79024,106.59411999999999,117.93392,99.79024,97.295484,86.18248,91.85237999999997,107.95489600000002,95.10312266666666,113.398,83.91452,101.604608,86.18248,97.52228000000001,79.3786,108.86208,109.70446514285713,79.3786,120.20188,83.91452,93.73154685714285,106.91811428571428,97.52228,92.98635999999999,82.62934266666667,81.64656000000001,102.0582,104.00864559999998,108.86208,107.62226186666663,99.79024,95.25432,94.34713599999999,106.59411999999999,138.34556,92.98636,99.79024,106.59411999999999,103.872568,81.25776685714287,87.39205866666664,108.748682,111.13004000000001,99.336648,111.13004,81.64656000000001,88.45044,89.68161828571428,104.32616,80.13458666666666,117.32913066666664,102.0582,106.59411999999999,99.79024,81.73160849999998,121.33586,96.82127418181818,95.63231333333333,79.3786,104.85535066666665,113.284602,122.46983999999999,114.33353350000002,107.7281,86.18248,78.38069759999999,95.35511822222223,103.35417714285713,113.39800000000001,83.46092800000001,92.532768,99.79024,102.568491,105.290043,107.047712,102.42107359999997,79.3786,108.86208000000002,111.13004,90.26480799999997,111.69702999999997,102.0582,93.666748,97.52228000000001,104.32616,115.66596000000001,104.32616,99.79024,91.625584,87.089664,98.62386057142858,84.21691466666665,104.1199818181818,92.98635999999999,106.59412,102.62519,88.45044,92.98635999999999,102.0582,88.45044,107.95489599999999,100.35722999999999,86.18248,108.86207999999999,98.42946399999998,93.89354399999999,106.59411999999999,97.52228000000001,111.13004,113.4887184,127.00576000000001,102.0582,88.45044,94.87632666666667,117.02673600000001,97.975872,91.171992,92.07917599999999,103.71057085714286,77.11064,83.91452,111.43243466666668,131.088088,96.90374545454547,86.18248,73.02831200000001,122.46983999999999,90.831798,111.28123733333335,101.49121,92.98635999999999,111.13004,119.29469599999999,97.52228000000001,84.71702892307692,111.13004,96.16150400000001,79.60539600000001,112.490816,109.0682581818182,106.59411999999999,94.12034000000001,106.140528,81.192968,107.954896,102.0582,106.59411999999999,86.18247999999998,92.98635999999999,108.86208000000002,77.11064,102.0582,97.52228000000001,97.52228000000001,106.27012571428575,90.7184,106.59411999999999,104.32616,105.02399384615386,111.13003999999998,108.86208000000003,92.88168492307692,95.25432,108.86208,131.36024319999999,113.398,110.26821519999999,80.28578399999998,102.33035519999999,102.0582,111.2207584,102.05819999999999,111.13003999999998,97.52228000000001,83.91452,108.86208000000003,88.61243714285713,83.91452,127.00576000000001,119.0679,109.769264,97.52228000000001,119.2039776,102.51179199999999,111.13004,127.45935200000001,97.97587199999998,84.30331314285715,85.85848571428569,111.13004,92.98635999999999,92.305972,98.42946400000001,74.84268,125.69538311111111,107.00647636363634,86.18248,114.75877600000001,84.594908,95.25432,93.63434857142856,102.0582,119.55389142857145,105.23334399999999,122.356442,95.25432,113.39800000000001,99.94143733333334,91.04828509090908,104.32616,104.32616,99.79024,118.10837846153846,114.7911754285714,119.37716727272728,91.171992,103.0002756923077,112.490816,82.61854285714286,91.85237999999998,94.49833333333333,114.758776,102.511792,88.45044,106.09012888888887,119.22989714285715,90.7184,87.57814769230768,99.79024000000001,95.25432,99.79024,108.86207999999999,109.4203470769231,123.02063028571426,98.93345511111112,79.3786,82.21355,108.86208,95.25432,102.05819999999999,86.18248,83.21668615384615,92.98635999999999,87.03296499999999,88.45043999999999,113.39800000000001,99.79024000000003,91.45112553846153,99.79024000000001,99.79024,107.95489599999999,107.64087076923076,100.35723,103.76789292307693,89.96241333333334,84.78681230769232,96.82444615384614,77.31681818181818,111.583632,103.91792719999998,108.86208,84.821704,122.1458457142857,103.418976,79.3786,99.3715396923077,96.53262472727275,102.81418666666667,124.7378,76.75784622222223,97.13348685714287,86.18248,100.810822,92.23037333333333,97.52228000000001,115.66596,104.77975200000002,83.91452,106.87761499999999,90.36948307692305,92.98635999999999,104.32616,86.18248,99.96469846153848,111.09514830769234,119.65756959999999,88.26144333333332,97.52228000000001,84.29251333333332,95.25432,111.88602666666668,94.800728,86.18248,97.52228000000001,93.24555542857145,95.25432,104.32616,111.86712700000001,113.70039466666664,101.49121,131.881874,97.52228000000001,122.46983999999999,124.7378,118.19851533333333,92.98635999999999,117.650425,110.15805714285715,105.97043100000002,86.636072,99.79024,92.079176,97.0182888888889,114.078388,86.18248,88.45044,81.64656000000001,108.86208,117.93392,98.55317090909092,92.98635999999999,125.51538628571427,101.96748159999999,97.06868800000002,89.48722171428571,90.71839999999999,91.171992,88.45044,95.25432,105.83813333333332,102.0582,87.31646,111.0,102.0582,112.490816,83.91452,111.13004,104.06156466666668,111.13004,91.54998533333332,98.42946400000001,106.140528,138.34556,99.79024,95.25432,102.05819999999999,79.3786,99.26104933333335,106.18176363636363,102.0582,115.66596000000003,129.27372,100.16823333333332,116.11955199999997,96.88725120000001,95.77271085714285,106.59411999999999,117.48032799999999,79.3786,113.39799999999998,117.93392,113.398,100.243832,115.66596000000001,83.91452000000001,98.83769680000002,81.64656,85.62808977777779,100.09263466666668,104.02376533333334,98.65626,103.72137066666664,95.83161890909088,90.71840000000002,113.60417818181818,92.98635999999999,86.636072,108.99167771428571,99.79024,113.398,113.89695119999999,86.0,92.532768,104.32616,97.068688,83.91452,87.13089963636364,81.64656,118.68990666666667,94.800728,87.31646,95.25432,94.34713599999999,85.3990029090909,106.59411999999999,99.79024,95.707912,79.3786,83.91452,115.87213818181816,92.98635999999999,111.13004,109.02702254545453,102.965384,92.98635999999999,77.11064,92.98635999999999,104.73851636363635,86.18248,85.275296,103.41897600000001,99.79024,117.93392,124.7378,83.007336,90.7184,83.91452,102.0582,102.63549890909093,88.45044,109.16447466666666,86.18248,111.810428,81.64656,116.42194666666667,103.41897599999997,99.33664800000001,120.20188,104.32616,90.71840000000002,102.0582,90.7184,106.59411999999999,111.13004,96.26230222222223,83.460928,102.96538400000001,113.77599333333335,104.32616,87.62572727272726,92.98635999999999,106.59411999999999,106.91811428571428,95.25432,120.20187999999999,90.94519599999998,81.3290456,83.91452,115.30308640000001,101.604608,113.624796,107.501304,115.66596000000001,114.75877600000001,93.32655399999999,114.248485,83.91452,104.32616,95.25432,112.83101000000002,103.72137066666669,90.7184,82.95693688888889,89.58442,90.3555264,117.93392,83.91452,101.92212239999999,111.13004,107.501304,114.11078742857146,110.97884266666667,89.58442,99.79024,83.91452,84.36811200000001,88.45044,86.03128266666666,98.88305600000002,114.15398666666667,105.23334399999999,101.77470499999998,92.53276799999999,115.66596000000001,118.68990666666667,100.243832,98.939755,103.04098266666666,92.98636,104.32615999999999,86.18248,88.45044,117.93391999999999,104.32616,102.0582,83.007336,97.52228000000001,100.69742399999998,112.150622,106.59412,109.99606,117.93391999999997,90.71839999999999,92.079176,108.10609333333333,93.893544,79.1064448,110.26821520000001,84.06571733333334,125.73570239999997,113.398,88.45043999999999,97.52228000000001,102.81418666666666,105.91373199999998,102.0582,89.811216,108.86208,88.75283466666666,92.98635999999999,86.18248,79.3786,83.91452,117.93392,91.171992,85.275296,77.61463111111112,88.45044,79.3786,102.0582,90.7184,108.86208,87.69445333333331,97.62307822222223,95.95990755555556,90.71840000000002,117.93392,84.56970844444446,88.45044,95.25432,102.28499599999999,92.59756685714285,95.25432,111.583632,90.83179799999999,121.71385333333335,101.2417344,83.91452,92.53276799999999,92.53276799999999,104.32616,117.93392,113.09560533333334,99.79024,79.491998,93.23835555555554,117.68192444444445,102.20939733333334,99.563444,93.43995199999999,97.52228000000001,111.48283377777777,86.27319839999998,115.66596,108.71088266666666,92.83516266666668,87.543256,104.23544159999999,90.37820599999999,86.636072,103.62057244444446,97.52228000000001,111.23083822222225,104.32616,111.63403111111111,92.98635999999999,108.40848799999999,86.18248,96.615096,87.089664,86.18248,113.398,108.30768977777777,85.89898499999998,93.439952,79.605396,90.11361066666666,115.89275599999999,86.636072,108.86208,96.16150400000002,114.90997333333333,94.800728,113.39800000000001,128.423235,92.98635999999999,86.409276,111.0,99.79024000000001,117.480328,100.92422000000002,104.32616,90.71839999999999,81.64656,99.79024,106.59411999999999,104.32615999999999,90.7184,100.243832,105.23334399999999,85.61549,99.03425333333335,105.686936,83.91452,108.86208,95.25432,118.08511733333334,97.52228000000001,96.3883,106.59412,96.615096,103.13548099999998,97.068688,111.69703000000001,117.93392,95.99140700000001,86.18248,113.398,163.29312,93.83684500000001,101.30221333333334,114.19178600000001,74.84268,79.75659333333334,97.52228,77.11064,83.0,87.42985799999998,90.7184,102.0582,85.842286,85.0485,94.290437,115.66596000000001,101.15101600000001,91.625584,99.79024000000001,93.13755733333333,105.7776544,112.36121828571427,104.32616,94.0,87.486557,100.980919,95.51351542857142,74.84268,88.45044,113.398,102.34169499999999,108.408488,99.336648,89.811216,111.13004,74.84268,104.32616,90.7184,101.37781199999998,111.13004,108.86208,97.52228,109.769264,89.811216,99.48784533333333,98.88305600000001,99.6995216,90.7184,105.68693600000002,97.52228000000001,120.00748342857143,112.8148102857143,108.86208,87.31646,92.59756685714285,83.91452,111.97242514285713,101.47501028571428,104.17496266666667,90.71839999999999,104.32616,100.17903314285714,107.24210857142857,102.0582,108.86208,116.119552,97.749076,86.18248000000001,87.47845714285712,110.54685028571429,80.058988,107.35010666666666,108.86208,87.99684800000001,106.140528,81.38736457142859,91.625584,113.398,83.91452,94.73592914285715,107.89009714285713,117.93392,103.3282576,108.86207999999999,98.202668,106.59411999999999,90.71839999999999,109.12127542857142,84.75690514285714,93.95834285714285,99.79024,119.06790000000001,108.40848799999999,98.88305600000001,90.1740896,82.40254666666665,99.79024,122.84783333333333,97.52228000000001,95.25432,131.54168,111.71322971428573,88.45044,95.25432,119.06790000000001,122.46983999999999,81.19296800000001,97.975872,108.86208,102.0582,122.923432,111.58363200000001,95.25431999999999,88.25604342857143,95.25432,102.0582,74.84268,92.079176,83.84972114285713,71.06274666666667,97.67347733333334,91.32318933333333,100.810822,95.25432,96.01030666666666,104.552956,83.91452,81.2836864,111.13004000000001,86.18248,86.18248,92.23037333333332,99.79024,100.6067056,99.33664800000001,108.86208,104.32615999999999,90.7184,115.66596000000001,100.697424,101.151016,108.33288933333334,113.398,90.7184,90.7184,86.78726933333333,108.86208,92.98635999999999,101.75580533333334,86.18248,117.93392,117.93392,79.83219199999998,97.52228000000001,92.98636,81.64656,94.34713599999999,104.32616,97.52228000000001,111.13004,111.13004,101.5138896,111.13004,99.60880319999998,83.91452,115.66596000000001,107.954896,92.23037333333333,98.52018239999998,91.171992,79.832192,95.25432,99.79024,97.82467466666667,109.769264,92.60836666666667,96.615096,107.04771199999999,87.69445333333333,106.59411999999999,98.429464,89.58441999999998,104.32616,86.18248,101.22661466666666,100.01703599999999,81.37440480000001,81.64656,98.88305600000001,83.1887728,92.079176,120.20188,106.59411999999999,99.79024,95.34503839999999,107.7281,108.86208,104.40175866666665,87.31646,88.90403199999999,104.779752,95.40551733333335,108.86208,96.615096,77.11064,110.22285600000001,93.36435333333333,100.243832,97.52228000000001,101.151016,90.7184,86.18248,83.91452,91.171992,83.91452,89.4483424,89.81121599999999,86.18248,102.0582,85.728888,90.7184,88.904032,101.60460800000001,114.90997333333333,103.418976,90.7184,82.100152,94.34713599999999,110.7671664,88.45044,95.25432,95.25432,115.66596000000001,105.23334400000002,99.79024,98.27826666666668,117.93392,108.86207999999999,103.872568,91.625584,96.615096,117.93392,99.79024,97.52228,106.59412,99.79024,104.32616,92.98635999999999,105.77765439999999,94.61929119999999,83.91452,86.18248,115.66596000000001,101.151016,90.7184,89.811216,99.79024,107.047712,116.119552,83.007336,102.51179200000001,88.45044,88.22364400000001,116.42194666666667,95.25432,86.18248,97.52228000000001,84.368112,106.59411999999999,99.4273664,89.811216,100.92421999999999,83.007336,107.95489599999999,94.34713599999999,88.45044,81.64656,94.34713599999999,99.79024,85.502092,103.19218000000001,98.65626,101.5138896,99.15521120000001,112.490816,112.490816,109.42907,101.9674816,74.389088,93.16779679999999,104.32616,86.18248,92.8956416,113.398,95.25432,90.7184,95.25432,98.88305600000001,115.212368,95.25432,81.55584160000001,81.64656,108.86208,95.25432,107.047712,88.904032,97.52228000000001,72.57472,92.6234864,97.975872,97.52228000000001,107.954896,81.64656,108.748682,104.50759680000002,77.11064,95.25432,100.0623952,90.71840000000002,86.18248,111.13003999999998,95.25432,92.98635999999999,99.79024,86.636072,108.4992064,88.904032,105.50549919999999,102.51179199999999,92.98635999999999,86.18248,92.98635999999999,100.697424,107.841498,99.79024000000001,102.0582,93.213156,81.759958,97.52228000000001,81.64656,108.86208,96.38830000000002,111.13004,82.55374400000001,100.697424,90.7184,96.16150400000001,120.76886999999999,85.728888,79.83219199999999,115.66596000000001,96.841892,95.25432,102.0582,120.655472,97.52228000000001,96.38829999999999,86.18248,99.79024,92.98635999999999,91.85238000000001,111.13004,87.31646,92.079176,97.52228000000001,96.95529000000002,99.79024,81.64656,117.93392,97.52228000000001,113.284602,92.532768,108.86208,91.171992,102.0582,94.34713599999999,99.79024,89.811216,109.99606,102.0582,93.780146,102.0582,91.625584,79.3786,90.71840000000002,97.52228000000001,102.0582,95.25432,81.64656,83.46092800000001,83.91452,90.7184,90.7184,113.398,90.7184,86.18248,90.7184,92.646166,102.96538400000001,112.94440800000001,85.955684,95.25432,90.71840000000002,111.13004,111.13004,103.645772,108.86208,102.0582,106.48072199999999,97.52228000000001,95.25432,94.914126,102.0582,87.089664,94.12034,79.151804,86.18248,90.26480799999999,86.18248,97.068688,95.25432,86.18248,102.965384,109.769264,99.79024,94.800728,103.872568,95.25432,96.501698,103.418976,100.92421999999999,95.25432,84.821704,83.91452,91.625584,97.52228000000001,86.18248,90.264808,91.171992,112.94440800000001,91.171992,89.811216,86.18248,113.398,86.18248,107.047712,97.52228000000001,92.98635999999999,119.74828799999999,99.79024,85.12409866666667,111.13004,93.439952,98.88305600000001,90.7184,102.965384,97.52228000000001,86.18248,99.79024,104.32616,97.52228000000001,105.23334399999999,86.18248,88.45044,86.18248,94.800728,97.068688,104.32616,92.98635999999999,75.749864,97.975872,84.821704,92.079176,104.77975199999999,79.3786,91.171992,97.52228000000001,88.45044,92.98635999999999,115.66596,99.79024,128.820128,92.98635999999999,93.89354399999999,92.98635999999999,107.047712,106.59411999999999,91.171992,88.45044,106.140528,141.067112,94.800728,97.068688,92.98635999999999,95.25432,104.32616,95.25432,97.975872,100.697424,97.975872,79.3786,104.32616,104.32616,106.140528,103.11658133333333,92.98635999999999,88.45044,106.140528,81.64656,87.08966400000001,106.59411999999999,108.86208,97.52228000000001,103.418976,101.45341066666667,94.34713599999999,90.264808,103.872568,95.25432,97.52228000000001,109.315672,86.18248,90.71840000000002,95.25432,98.73185866666667,92.98635999999999,108.86208,86.18248,97.52228000000001,99.79024,99.79024,92.98635999999999,88.45044,113.398,79.3786,92.98635999999999,83.91452,78.92500799999999,97.975872,87.996848,83.91452,81.64656,95.25432,83.91452,91.171992,115.66596,105.68693600000002,104.09936400000001,104.32616,100.243832,107.047712,90.71840000000002,97.52228000000001,113.39799999999998,79.3786,99.79024,81.64656,88.45044,77.11064,104.32616,104.32616,103.418976,79.3786,90.7184,108.86208,108.86208,99.79024,102.0582,90.7184,90.7184,97.52228000000001,86.18248,86.18248,99.79024,90.7184,79.3786,83.91452,95.25432,106.140528,111.13004,108.86208,122.46983999999999,88.45044,97.52228000000001,92.98635999999999,72.57472,83.91452,124.7378,97.52228000000001,95.25432,107.7281,99.79024,95.25432,114.758776,111.13004,88.45044,86.18248,102.0582,83.007336,97.52228000000001,92.98635999999999,88.45044,79.3786,102.0582,106.59411999999999,113.398,90.7184,103.872568,83.91452,86.18248,105.23334399999999,90.7184,108.86208,90.7184,83.91452,102.0582,104.32616,86.18248,97.52228000000001,104.32616,102.965384,83.91452,86.18248,88.45044,95.25432,86.18248,104.779752,86.18248,102.0582,97.52228000000001,88.45044,86.18248,104.32616,113.398,74.84268,83.91452,85.275296,83.91452,90.7184,83.007336,97.52228000000001,95.25432,86.18248,111.13004,88.45044,97.52228000000001,95.25432,88.904032,87.089664,92.079176,86.18248,93.439952,84.821704,93.439952,89.357624,99.79024,88.45044,97.52228000000001,106.59411999999999,113.398,92.98635999999999,90.7184,108.86208,92.98635999999999,106.140528,92.98635999999999,80.28578399999998,120.20188,81.64656,92.98635999999999,115.66596000000001,113.398,109.769264,87.543256,86.18248,92.079176,113.398,99.336648,105.23334399999999,91.625584,93.439952,86.18248,92.98635999999999,99.336648,84.368112,117.02673600000001,102.0582,85.275296,76.657048,78.92500799999999,99.79024,95.25432,99.79024,86.18248,99.79024,78.92500799999999,90.7184,86.18248,95.25432,90.7184,89.357624,94.800728,110.22285600000001,120.20188,91.625584,92.079176,92.532768,83.91452,86.18248,97.52228000000001,104.32616,78.471416,92.532768,102.511792,88.904032,101.604608,102.0582,97.52228000000001,108.86208,98.429464,102.0582,83.91452,79.83219199999998,86.18248,83.91452,90.7184,92.98635999999999,92.98635999999999,90.7184,95.25432,99.79024,124.7378,90.7184,80.73937600000001,107.501304,86.18248,102.0582,104.32616,86.18248,93.439952,74.84268,97.52228000000001,111.13004,93.439952,88.45044,94.800728,103.872568,108.86208,81.19296800000001,92.079176,83.91452,90.7184,85.728888,85.728888,92.98635999999999,97.52228000000001,81.19296800000001,90.7184,90.7184,75.749864,100.243832,93.439952,97.52228000000001,102.511792,95.707912,88.45044,88.45044,97.52228000000001,112.490816,99.79024,83.91452,96.615096,110.22285600000001,87.089664,97.52228000000001,99.79024,92.98635999999999,112.490816]\n",
       "},\n",
       "\"ggsize\":{\n",
       "\"width\":500.0,\n",
       "\"height\":500.0\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"Weight (kg)\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Height\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"#233d4d\",\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"point\",\n",
       "\"data\":{\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"smooth\",\n",
       "\"se\":false,\n",
       "\"size\":2.0,\n",
       "\"color\":\"#92140c\",\n",
       "\"method\":\"lm\",\n",
       "\"deg\":1.0,\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"smooth\",\n",
       "\"data\":{\n",
       "\"player_height\":[176.6128797672774,177.39827573330868,178.18367169933995,178.96906766537123,179.75446363140253,180.53985959743378,181.32525556346505,182.11065152949635,182.89604749552763,183.6814434615589,184.46683942759017,185.25223539362145,186.03763135965272,186.823027325684,187.60842329171527,188.39381925774654,189.17921522377782,189.9646111898091,190.75000715584036,191.53540312187164,192.3207990879029,193.1061950539342,193.89159101996546,194.67698698599673,195.462382952028,196.24777891805928,197.03317488409056,197.81857085012183,198.6039668161531,199.38936278218438,200.17475874821565,200.96015471424693,201.7455506802782,202.53094664630947,203.31634261234075,204.10173857837202,204.8871345444033,205.67253051043457,206.45792647646584,207.24332244249712,208.0287184085284,208.81411437455967,209.59951034059094,210.3849063066222,211.1703022726535,211.95569823868476,212.74109420471606,213.5264901707473,214.3118861367786,215.09728210280988,215.88267806884116,216.66807403487243,217.4534700009037,218.23886596693498,219.02426193296623,219.80965789899753,220.5950538650288,221.38044983106005,222.16584579709135,222.95124176312262,223.7366377291539,224.52203369518517,225.30742966121647,226.09282562724772,226.87822159327902,227.6636175593103,228.44901352534154,229.23440949137284,230.01980545740412,230.8052014234354,231.59059738946667,232.37599335549794,233.1613893215292,233.9467852875605,234.73218125359176,235.51757721962304,236.3029731856543,237.08836915168558,237.87376511771686,238.65916108374813],\n",
       "\"player_weight\":[60.327736,61.63109529113924,62.934454582278484,64.23781387341772,65.54117316455697,66.8445324556962,68.14789174683544,69.45125103797469,70.75461032911393,72.05796962025316,73.3613289113924,74.66468820253165,75.9680474936709,77.27140678481013,78.57476607594937,79.87812536708861,81.18148465822784,82.48484394936709,83.78820324050633,85.09156253164556,86.39492182278481,87.69828111392405,89.00164040506328,90.30499969620253,91.60835898734177,92.911718278481,94.21507756962026,95.5184368607595,96.82179615189872,98.12515544303798,99.42851473417721,100.73187402531646,102.0352333164557,103.33859260759493,104.64195189873418,105.94531118987342,107.24867048101265,108.5520297721519,109.85538906329114,111.15874835443037,112.46210764556962,113.76546693670886,115.06882622784809,116.37218551898734,117.67554481012658,118.97890410126581,120.28226339240507,121.5856226835443,122.88898197468355,124.19234126582279,125.49570055696202,126.79905984810127,128.1024191392405,129.40577843037974,130.70913772151897,132.01249701265823,133.31585630379746,134.6192155949367,135.92257488607595,137.22593417721518,138.5292934683544,139.83265275949367,141.13601205063293,142.43937134177213,143.7427306329114,145.04608992405065,146.34944921518985,147.6528085063291,148.95616779746837,150.2595270886076,151.56288637974683,152.8662456708861,154.16960496202532,155.47296425316455,156.7763235443038,158.07968283544304,159.38304212658227,160.68640141772153,161.98976070886076,163.29312]\n",
       "}\n",
       "}],\n",
       "\"theme\":{\n",
       "\"title\":{\n",
       "\"hjust\":0.5,\n",
       "\"blank\":false\n",
       "}\n",
       "}\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"SL3lO6\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 10,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val corrHeightWeight = ggplot(physical_data.toMap()) { x=\"player_weight\" ; y=\"player_height\"} +\n",
    "    geomPoint(color = \"#233d4d\") +\n",
    "    labs(title = \"Height and Weight Correlation\", x = \"Weight (kg)\", y = \"Height\") +\n",
    "    theme(title = elementText(hjust = 0.5)) +\n",
    "    ggsize(500, 500)\n",
    "\n",
    "// Adding correlation\n",
    "val correlation = physical_data.corr { player_weight }\n",
    "        .with { player_height }[\"player_height\"].values().toList()[0]\n",
    "\n",
    "println(\"Correlation: $correlation\")\n",
    "corrHeightWeight + \n",
    "    geomSmooth(method = \"lm\", deg = 1, color =\"#92140c\", size = 2.0, se = false)"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "1b82e286-9e0d-4b4b-8170-1178a4a05eec",
   "metadata": {},
   "source": [
    "We can determine that height and weight are fairly strong correlated variables."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "81567353-6f60-45b8-95b5-dd5de0c20d09",
   "metadata": {},
   "source": [
    "Let's see now the top 10 players with highest BMI:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "id": "99c6ff31-045b-44bc-9aaf-7324042be3cf",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"1tWIvh\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Top 10 players by BMI\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"player_name\",\n",
       "\"y\":\"BMI\"\n",
       "},\n",
       "\"coord\":{\n",
       "\"name\":\"flip\",\n",
       "\"flip\":true\n",
       "},\n",
       "\"data\":{\n",
       "\"player_name\":[\"Oliver Miller\",\"Zion Williamson\",\"Sim Bhullar\",\"James Lang\",\"Thomas Hamilton\",\"Shaquille O'Neal\",\"Robert Traylor\",\"Garret Siler\",\"Jahidi White\",\"Glen Davis\",\"DeJuan Blair\"],\n",
       "\"BMI\":[34.07650418410119,32.40238512608147,31.953647545724575,31.891143199300075,31.37003407592537,31.301572822292105,31.27715467038077,31.127311202220024,31.076057274809266,30.968898456620266,30.33591403781795]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"BMI rate\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Player\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"alpha\":0.7,\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"bar\",\n",
       "\"fill\":\"#004643\",\n",
       "\"data\":{\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"1tWIvh\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 11,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val topBMI = physical_data.sortBy { BMI.desc() }[0..10]\n",
    "\n",
    "ggplot(topBMI.toMap()) { x = \"player_name\" ; y = \"BMI\" } +\n",
    "    geomBar(stat = Stat.identity, fill = \"#004643\", alpha=0.7) +\n",
    "    coordFlip() +\n",
    "    labs(title = \"Top 10 players by BMI\", x = \"BMI rate\", y = \"Player\")"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "9231bb7d-778b-4f80-81ff-be0ac30e389b",
   "metadata": {},
   "source": [
    "According to ourworldindata.org, 95% of male height lie between 163cm to 193cm. With the average of 203 cm, most of NBA Players are on 5% of entire population with height above 193cm. \n",
    "\n",
    "We can then get the highest and the shortest player ever in the NBA:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 12,
   "id": "49e3fb16-34e0-435b-aa94-cd44b463c9bc",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":2,\"ncol\":4,\"columns\":[\"player_name\",\"player_height\",\"player_weight\",\"BMI\"],\"kotlin_dataframe\":[{\"player_name\":\"Muggsy Bogues\",\"player_height\":160.02,\"player_weight\":63.502880000000005,\"BMI\":24.7996122094537},{\"player_name\":\"Gheorghe Muresan\",\"player_height\":231.14,\"player_weight\":137.438376,\"BMI\":25.72514296097304}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410173\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 2, columnsCount = 4</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"player_name: String\\\">player_name</span>\", children: [], rightAlign: false, values: [\"Muggsy Bogues\",\"Gheorghe Muresan\"] }, \n",
       "{ name: \"<span title=\\\"player_height: Double\\\">player_height</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">160.02</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">231.14</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"player_weight: Double\\\">player_weight</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">63.502880</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">137.438376</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"BMI: Double\\\">BMI</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">24.799612</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">25.725143</span></span>\"] }, \n",
       "], id: -1023410173, rootId: -1023410173, totalRows: 2 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410173) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 12,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "physical_data.minBy { player_height }.concat(\n",
    "    physical_data.maxBy { player_height}\n",
    ")"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "d0dc7816-9bdc-4f9f-94c1-e8997f830c9c",
   "metadata": {},
   "source": [
    "### Players Nationalities"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "fd8928bd-0c26-4bdd-9a02-f69c508850ac",
   "metadata": {},
   "source": [
    "Being the NBA USA's professional basketball league, most of the players are from North America. We can create a frame and a plot visualizing each year how many new players were from USA and how many of them are foreigners.\n",
    "\n",
    "Let's first visualize top 15 countries."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 13,
   "id": "8b9a2607-c139-4862-a37d-3ce78fa0dd44",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"vi2mIK\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Top 15 Players Nationalities\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"country\",\n",
       "\"y\":\"count\"\n",
       "},\n",
       "\"data\":{\n",
       "\"country\":[\"USA\",\"Canada\",\"France\",\"Australia\",\"Croatia\",\"Argentina\",\"Spain\",\"Serbia\",\"Germany\",\"Brazil\",\"Lithuania\",\"Turkey\",\"Nigeria\",\"Slovenia\",\"Senegal\",\"Greece\"],\n",
       "\"count\":[2067.0,39.0,35.0,19.0,15.0,14.0,14.0,14.0,13.0,13.0,12.0,12.0,11.0,10.0,10.0,9.0]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"y\",\n",
       "\"trans\":\"log10\"\n",
       "},{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"Country\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Count (log)\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"bar\",\n",
       "\"fill\":\"#456990\",\n",
       "\"data\":{\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"vi2mIK\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 13,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val topCountries = df.distinctBy { player_name }\n",
    "    .select { player_name and country }\n",
    "    .groupBy { country }\n",
    "    .count()\n",
    "    .sortBy { \"count\"<Int>().desc() }\n",
    "    \n",
    "ggplot(topCountries[0..15].toMap()) { x = \"country\" ; y=\"count\" } +\n",
    "    geomBar(stat = Stat.identity, fill = \"#456990\") +\n",
    "    scaleYLog10() +\n",
    "    labs(title = \"Top 15 Players Nationalities\", x = \"Country\", y = \"Count (log)\")\n",
    "    "
   ]
  },
  {
   "cell_type": "markdown",
   "id": "c212dfb7-446c-47e7-95c8-144f95e17211",
   "metadata": {},
   "source": [
    "We can see during the years how many USA players have been vs. how many foreign players."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 14,
   "id": "acfa2361-84b4-4111-8430-6212884d9f8a",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":5,\"ncol\":3,\"columns\":[\"season\",\"country\",\"count\"],\"kotlin_dataframe\":[{\"season\":2019,\"country\":\"USA\",\"count\":1894},{\"season\":2020,\"country\":\"Non-USA\",\"count\":363},{\"season\":2020,\"country\":\"USA\",\"count\":1970},{\"season\":2021,\"country\":\"Non-USA\",\"count\":396},{\"season\":2021,\"country\":\"USA\",\"count\":2067}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410172\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 5, columnsCount = 3</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"season: Int\\\">season</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2019</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2020</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2020</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2021</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2021</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"country: String\\\">country</span>\", children: [], rightAlign: false, values: [\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\"] }, \n",
       "{ name: \"<span title=\\\"count: Int\\\">count</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1894</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">363</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1970</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">396</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2067</span></span>\"] }, \n",
       "], id: -1023410172, rootId: -1023410172, totalRows: 5 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410172) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 14,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val yearNationalities = df.distinctBy { player_name }\n",
    "    .groupBy { season.map { it.split('-')[0] } }\n",
    "    .aggregate {\n",
    "        count { country != \"USA\" } into \"Non-USA\"\n",
    "        count { country == \"USA\" } into \"USA\" \n",
    "    }.cumSum()\n",
    "    .gather(\"Non-USA\", \"USA\").into(\"country\", \"count\")\n",
    "    .convert { season }.toInt()\n",
    "    \n",
    "yearNationalities.tail(5)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 15,
   "id": "0d04bb37-64c7-43b9-8f2e-55e5a3905ff9",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"TEytxE\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"All time Player's Countries\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"season\",\n",
       "\"y\":\"count\"\n",
       "},\n",
       "\"data\":{\n",
       "\"country\":[\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\",\"Non-USA\",\"USA\"],\n",
       "\"count\":[9.0,432.0,14.0,513.0,22.0,580.0,26.0,639.0,42.0,692.0,56.0,748.0,72.0,796.0,84.0,851.0,100.0,905.0,115.0,975.0,122.0,1046.0,132.0,1099.0,141.0,1152.0,147.0,1203.0,160.0,1256.0,171.0,1326.0,189.0,1384.0,208.0,1441.0,227.0,1504.0,245.0,1559.0,273.0,1619.0,295.0,1720.0,316.0,1804.0,345.0,1894.0,363.0,1970.0,396.0,2067.0],\n",
       "\"season\":[1996.0,1996.0,1997.0,1997.0,1998.0,1998.0,1999.0,1999.0,2000.0,2000.0,2001.0,2001.0,2002.0,2002.0,2003.0,2003.0,2004.0,2004.0,2005.0,2005.0,2006.0,2006.0,2007.0,2007.0,2008.0,2008.0,2009.0,2009.0,2010.0,2010.0,2011.0,2011.0,2012.0,2012.0,2013.0,2013.0,2014.0,2014.0,2015.0,2015.0,2016.0,2016.0,2017.0,2017.0,2018.0,2018.0,2019.0,2019.0,2020.0,2020.0,2021.0,2021.0]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"breaks\":[1996.0,1999.0,2002.0,2005.0,2008.0,2011.0,2014.0,2017.0,2020.0]\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"fill\":\"country\"\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"area\",\n",
       "\"data\":{\n",
       "}\n",
       "}],\n",
       "\"theme\":{\n",
       "\"title\":{\n",
       "\"hjust\":0.5,\n",
       "\"blank\":false\n",
       "}\n",
       "}\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"TEytxE\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 15,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "ggplot(yearNationalities.toMap()) { x=\"season\"; y=\"count\"} +\n",
    "    geomArea(stat = Stat.identity) { fill=\"country\"} +\n",
    "    scaleXContinuous(breaks = (1996..2021 step 3).toList()) +\n",
    "    theme(title = elementText(hjust = 0.5)) +\n",
    "    ggtitle(\"All time Player's Countries\")"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "2af1be6e-cd33-46ab-920a-0bbe75e34546",
   "metadata": {},
   "source": [
    "And we can plot the overall percentage of USA and foreign players."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 16,
   "id": "6f9d6fbe-61ec-43ea-9bfa-cafaf6ab7721",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"P4pcE9\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Country Percentage\"\n",
       "},\n",
       "\"mapping\":{\n",
       "},\n",
       "\"data\":{\n",
       "\"country\":[\"USA\",\"non-USA\"],\n",
       "\"count\":[2067.0,396.0]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"fill\",\n",
       "\"scale_mapper_kind\":\"color_brewer\",\n",
       "\"palette\":\"Pastel1\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"hole\":0.3,\n",
       "\"mapping\":{\n",
       "\"slice\":\"count\",\n",
       "\"fill\":\"country\"\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"size\":30.0,\n",
       "\"stroke_color\":\"white\",\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"pie\",\n",
       "\"stroke\":1.0,\n",
       "\"labels\":{\n",
       "\"lines\":[\"@count\"],\n",
       "\"annotation_size\":16\n",
       "},\n",
       "\"data\":{\n",
       "}\n",
       "}],\n",
       "\"theme\":{\n",
       "\"title\":{\n",
       "\"hjust\":0.5,\n",
       "\"blank\":false\n",
       "},\n",
       "\"axis\":{\n",
       "\"blank\":true\n",
       "},\n",
       "\"line\":{\n",
       "\"blank\":true\n",
       "},\n",
       "\"legend_position\":\"bottom\"\n",
       "}\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"P4pcE9\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 16,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val countNations = df.distinctBy { player_name }\n",
    "    .groupBy { country.map { it == \"USA\" } }.count()\n",
    "    .convert(\"country\").with { if (\"country\"<Boolean>()) \"USA\" else \"non-USA\" }\n",
    "    .toMap()\n",
    "\n",
    "ggplot(countNations) +\n",
    "    geomPie(stat = Stat.identity,\n",
    "            size = 30, stroke = 1, strokeColor = \"white\", hole = 0.3,\n",
    "            labels = layerLabels().line(\"@count\").size(16),\n",
    "    ) { slice = \"count\" ; fill = \"country\" } +\n",
    "    theme(\n",
    "        line = elementBlank(),\n",
    "        axis = elementBlank(),\n",
    "        title = elementText(hjust=0.5)\n",
    "    ).legendPositionBottom() +\n",
    "    scaleFillBrewer(palette = \"Pastel1\") +\n",
    "    ggtitle(\"Country Percentage\")\n",
    "\n",
    "    \n",
    "    "
   ]
  },
  {
   "cell_type": "markdown",
   "id": "31c7a46e-a210-4bf3-8b08-3dea5e473329",
   "metadata": {},
   "source": [
    "And finally, we can visualize foreign players trend since 1996"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 17,
   "id": "ad6248e2-e922-4974-a770-30314eb1b2ac",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"mfunRX\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Foreign Players on NBA trend\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"@as_discrete@season\",\n",
       "\"y\":\"count\"\n",
       "},\n",
       "\"data\":{\n",
       "\"count\":[9.0,14.0,22.0,24.0,40.0,51.0,62.0,61.0,74.0,80.0,71.0,70.0,70.0,75.0,83.0,83.0,85.0,92.0,101.0,101.0,115.0,114.0,118.0,125.0,124.0,133.0]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"#243e36\",\n",
       "\"size\":2.0,\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"line\",\n",
       "\"data\":{\n",
       "\"@as_discrete@season\":[1996.0,1997.0,1998.0,1999.0,2000.0,2001.0,2002.0,2003.0,2004.0,2005.0,2006.0,2007.0,2008.0,2009.0,2010.0,2011.0,2012.0,2013.0,2014.0,2015.0,2016.0,2017.0,2018.0,2019.0,2020.0,2021.0]\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"#7ca982\",\n",
       "\"size\":5.0,\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"point\",\n",
       "\"data\":{\n",
       "\"@as_discrete@season\":[1996.0,1997.0,1998.0,1999.0,2000.0,2001.0,2002.0,2003.0,2004.0,2005.0,2006.0,2007.0,2008.0,2009.0,2010.0,2011.0,2012.0,2013.0,2014.0,2015.0,2016.0,2017.0,2018.0,2019.0,2020.0,2021.0]\n",
       "}\n",
       "}],\n",
       "\"data_meta\":{\n",
       "\"mapping_annotations\":[{\n",
       "\"aes\":\"x\",\n",
       "\"annotation\":\"as_discrete\",\n",
       "\"parameters\":{\n",
       "\"label\":\"season\"\n",
       "}\n",
       "}]\n",
       "}\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"mfunRX\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 17,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val foreignersCount = df.groupBy { season.map { it.split('-')[0] } }\n",
    "                        .count { country != \"USA\" }\n",
    "                        .convert { season }.toInt().toMap() \n",
    "\n",
    "ggplot(foreignersCount) { x = asDiscrete(\"season\") ; y = \"count\" } +\n",
    "    geomLine(color = \"#243e36\", size = 2.0) +\n",
    "    geomPoint(size = 5.0, color=\"#7ca982\") +\n",
    "    ggtitle(\"Foreign Players on NBA trend\")"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "a23b638c-9092-42b5-b0a9-50bf977381c0",
   "metadata": {},
   "source": [
    "Not surprisingly, as the USA Basketball League, North American players are still dominating the NBA, with the USA only at 84%, but the number of the foreign players is increasing progressively. Even if they are the minority of the league, since 2019 to today (2023) NBA's Most Valuable Player prize has been won by foreigners!"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "ba1cabeb-67e6-404b-8369-1fbab7a9a8e4",
   "metadata": {},
   "source": [
    "### Players Statistics"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "88d21c77-9211-4467-901c-e2c01fd918dd",
   "metadata": {},
   "source": [
    "In this section we will go through in game statistics for evaluating a player excellence, analyzing points, assists and rebounds per game."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "16f6b567-a563-4b4b-87ac-9e6c52ee2b6e",
   "metadata": {},
   "source": [
    "#### Points Per Game"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 18,
   "id": "47e42038-a70d-44aa-b974-152038cf55bc",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"dPMTRl\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Points per Game Distribution\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"pts\"\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"Points-per-game\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Games\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"y\":\"..count..\"\n",
       "},\n",
       "\"stat\":\"bin\",\n",
       "\"alpha\":0.8,\n",
       "\"position\":\"stack\",\n",
       "\"binwidth\":2.0,\n",
       "\"geom\":\"histogram\",\n",
       "\"fill\":\"#840032\",\n",
       "\"data\":{\n",
       "\"..count..\":[243.0,1732.0,2167.0,1889.0,1531.0,1218.0,947.0,731.0,530.0,428.0,334.0,226.0,120.0,90.0,77.0,27.0,11.0,2.0,2.0,0.0],\n",
       "\"pts\":[-0.3999999999999999,1.6,3.6,5.6,7.6,9.6,11.6,13.6,15.6,17.6,19.6,21.6,23.6,25.6,27.6,29.6,31.6,33.6,35.6,37.6]\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"#fcba04\",\n",
       "\"size\":2.0,\n",
       "\"linetype\":\"dashed\",\n",
       "\"position\":\"identity\",\n",
       "\"xintercept\":8.172775294595697,\n",
       "\"geom\":\"vline\",\n",
       "\"data\":{\n",
       "}\n",
       "}],\n",
       "\"theme\":{\n",
       "\"title\":{\n",
       "\"hjust\":0.5,\n",
       "\"blank\":false\n",
       "}\n",
       "}\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"dPMTRl\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 18,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "ggplot(df.toMap()) { x=\"pts\" } +\n",
    "    geomHistogram(binWidth = 2, fill = \"#840032\", alpha=0.8) { y=\"..count..\" } +\n",
    "    geomVLine(xintercept = df.pts.mean(), color = \"#fcba04\",\n",
    "              size = 2.0, linetype = \"dashed\") +\n",
    "    labs(title=\"Points per Game Distribution\",\n",
    "         x=\"Points-per-game\",\n",
    "         y=\"Games\") +\n",
    "    theme(title = elementText(hjust=.5))"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "51ce746f-b41f-4f02-bdd7-ed1140227a44",
   "metadata": {},
   "source": [
    "We can see that exceptional performances are above 25 points per game.\n",
    "\n",
    "We can write a simple `quantile` function to extract the top 1% and 10% of point per game performances."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 19,
   "id": "a739bdde-1f54-44b5-984a-5d9f811d265e",
   "metadata": {
    "tags": []
   },
   "outputs": [],
   "source": [
    "fun quantile(perc: Double=0.99, data: List<Double>): List<Double> = \n",
    "    data.sortedDescending()\n",
    "        .subList(0, (perc * data.size).toInt())"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 20,
   "id": "bf5f81c1-f2e1-4af1-a5b8-f256b2c2a097",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":10,\"ncol\":2,\"columns\":[\"Percentile\",\"PPG\"],\"kotlin_dataframe\":[{\"Percentile\":0.99,\"PPG\":28.452845528455303},{\"Percentile\":0.98,\"PPG\":26.76382113821141},{\"Percentile\":0.97,\"PPG\":25.46260162601629},{\"Percentile\":0.96,\"PPG\":24.484756097561014},{\"Percentile\":0.95,\"PPG\":23.699186991869944},{\"Percentile\":0.94,\"PPG\":23.049593495934992},{\"Percentile\":0.93,\"PPG\":22.4729384436702},{\"Percentile\":0.92,\"PPG\":21.960772357723584},{\"Percentile\":0.91,\"PPG\":21.492953929539276},{\"Percentile\":0.9,\"PPG\":21.061707317073157}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410171\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 10, columnsCount = 2</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"Percentile: Double\\\">Percentile</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.99</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.98</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.97</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.96</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.95</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.94</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.93</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.92</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.91</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.90</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"PPG: Double\\\">PPG</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">28.452846</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">26.763821</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">25.462602</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">24.484756</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">23.699187</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">23.049593</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">22.472938</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">21.960772</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">21.492954</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">21.061707</span></span>\"] }, \n",
       "], id: -1023410171, rootId: -1023410171, totalRows: 10 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410171) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 20,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val ppgQuantile = (1..10).map {\n",
    "    quantile(it.toDouble() / 100.0, df.pts.toList()).average()\n",
    "}\n",
    "\n",
    "val ppgDf = dataFrameOf(\n",
    "    \"Percentile\" to (99 downTo 90).map { it.toDouble() / 100 },\n",
    "    \"PPG\" to ppgQuantile\n",
    ")\n",
    "\n",
    "ppgDf"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "f0b0fec7-3a9d-47c4-b1c8-e2f7778182bf",
   "metadata": {},
   "source": [
    "Let's rank now the top 10 players to have a point-per-game statistic in the top 1%, and the highest number of seasons played with the team."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 21,
   "id": "c586e232-d94d-4195-807d-3237c73904ef",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":11,\"ncol\":3,\"columns\":[\"player_name\",\"Seasons\",\"Avg PPG\"],\"kotlin_dataframe\":[{\"player_name\":\"James Harden\",\"Seasons\":5,\"Avg PPG\":31.779999999999994},{\"player_name\":\"Allen Iverson\",\"Seasons\":4,\"Avg PPG\":31.55},{\"player_name\":\"Kobe Bryant\",\"Seasons\":4,\"Avg PPG\":31.375},{\"player_name\":\"LeBron James\",\"Seasons\":4,\"Avg PPG\":30.349999999999998},{\"player_name\":\"Kevin Durant\",\"Seasons\":3,\"Avg PPG\":30.666666666666668},{\"player_name\":\"Michael Jordan\",\"Seasons\":2,\"Avg PPG\":29.15},{\"player_name\":\"Shaquille O'Neal\",\"Seasons\":2,\"Avg PPG\":29.2},{\"player_name\":\"Carmelo Anthony\",\"Seasons\":2,\"Avg PPG\":28.799999999999997},{\"player_name\":\"Stephen Curry\",\"Seasons\":2,\"Avg PPG\":31.05},{\"player_name\":\"Damian Lillard\",\"Seasons\":2,\"Avg PPG\":29.4},{\"player_name\":\"Bradley Beal\",\"Seasons\":2,\"Avg PPG\":30.9}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410170\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 11, columnsCount = 3</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"player_name: String\\\">player_name</span>\", children: [], rightAlign: false, values: [\"James Harden\",\"Allen Iverson\",\"Kobe Bryant\",\"LeBron James\",\"Kevin Durant\",\"Michael Jordan\",\"Shaquille O&#39;Neal\",\"Carmelo Anthony\",\"Stephen Curry\",\"Damian Lillard\",\"Bradley Beal\"] }, \n",
       "{ name: \"<span title=\\\"Seasons: Int\\\">Seasons</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">4</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">4</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">4</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"Avg PPG: Double\\\">Avg PPG</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">31.780000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">31.550000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">31.375000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">30.350000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">30.666667</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">29.150000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">29.200000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">28.800000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">31.050000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">29.400000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">30.900000</span></span>\"] }, \n",
       "], id: -1023410170, rootId: -1023410170, totalRows: 11 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410170) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 21,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "df.filter { pts >= ppgDf.PPG[0] }\n",
    "    .update { season }.with { it.split('-')[0] }\n",
    "    .convert { season }.toInt()\n",
    "    .groupBy { player_name }.aggregate {\n",
    "        count() into \"Seasons\"\n",
    "        mean { pts } into \"Avg PPG\"\n",
    "    }.sortBy { \"Seasons\"<Int>().desc() }[0..10]"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "3082641f-a66d-43ad-9489-043433c2b04b",
   "metadata": {},
   "source": [
    "From the above dataframe, James Harden has the highest number of seasons averaging 31.78 points per game. Now we have a clearer picture of what characterized an excellent scorer. "
   ]
  },
  {
   "cell_type": "markdown",
   "id": "eda6483c-0342-4afe-8c9c-5f4dbd88c86e",
   "metadata": {},
   "source": [
    "### Rebound Per Game"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "6ddc2220-ad24-4335-b0a1-c32b4dee6aba",
   "metadata": {},
   "source": [
    "Similarly as above, we can understand what values of rebounds per game characterize the best rebounder in the league."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 22,
   "id": "91dca390-b75f-4f1d-a8e1-391de1446719",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"k9eV4p\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Rebounds per Game Distribution\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"reb\"\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"Rebounds-per-game\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Games\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"y\":\"..count..\"\n",
       "},\n",
       "\"stat\":\"bin\",\n",
       "\"alpha\":0.8,\n",
       "\"position\":\"stack\",\n",
       "\"binwidth\":1.0,\n",
       "\"geom\":\"histogram\",\n",
       "\"fill\":\"#840032\",\n",
       "\"data\":{\n",
       "\"..count..\":[191.0,1572.0,2610.0,2365.0,1852.0,1243.0,798.0,542.0,410.0,255.0,205.0,111.0,72.0,36.0,27.0,11.0,4.0,1.0],\n",
       "\"reb\":[-0.19999999999999996,0.8,1.8,2.8,3.8,4.8,5.8,6.8,7.8,8.8,9.8,10.8,11.8,12.8,13.8,14.8,15.8,16.8]\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"#fcba04\",\n",
       "\"size\":2.0,\n",
       "\"linetype\":\"dashed\",\n",
       "\"position\":\"identity\",\n",
       "\"xintercept\":3.55915481511582,\n",
       "\"geom\":\"vline\",\n",
       "\"data\":{\n",
       "}\n",
       "}],\n",
       "\"theme\":{\n",
       "\"title\":{\n",
       "\"hjust\":0.5,\n",
       "\"blank\":false\n",
       "}\n",
       "}\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"k9eV4p\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 22,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "ggplot(df.toMap()) { x=\"reb\" } +\n",
    "    geomHistogram(binWidth = 1, fill = \"#840032\", alpha=0.8) { y=\"..count..\" } +\n",
    "    geomVLine(xintercept = df.reb.mean(), color = \"#fcba04\",\n",
    "              size = 2.0, linetype = \"dashed\") +\n",
    "    labs(title=\"Rebounds per Game Distribution\",\n",
    "         x=\"Rebounds-per-game\",\n",
    "         y=\"Games\") +\n",
    "    theme(title = elementText(hjust=.5))"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "36af5d89-1e62-4eae-8366-b803aee43394",
   "metadata": {},
   "source": [
    "On average, an NBA player take 3 to 4 rebounds per game.\n",
    "\n",
    "We can find the best 1% to 10% rebound per games values"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 23,
   "id": "75b69da9-e642-40c9-b4be-648605645ffb",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":10,\"ncol\":2,\"columns\":[\"Percentile\",\"reb\"],\"kotlin_dataframe\":[{\"Percentile\":0.99,\"reb\":12.92926829268293},{\"Percentile\":0.98,\"reb\":11.934959349593496},{\"Percentile\":0.97,\"reb\":11.302168021680224},{\"Percentile\":0.96,\"reb\":10.832926829268308},{\"Percentile\":0.95,\"reb\":10.440162601626023},{\"Percentile\":0.94,\"reb\":10.100948509485102},{\"Percentile\":0.93,\"reb\":9.805342624854823},{\"Percentile\":0.92,\"reb\":9.541869918699197},{\"Percentile\":0.91,\"reb\":9.306052393857248},{\"Percentile\":0.9,\"reb\":9.092439024390247}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410169\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 10, columnsCount = 2</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"Percentile: Double\\\">Percentile</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.99</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.98</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.97</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.96</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.95</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.94</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.93</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.92</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.91</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.90</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"reb: Double\\\">reb</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">12.929268</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">11.934959</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">11.302168</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.832927</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.440163</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.100949</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9.805343</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9.541870</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9.306052</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9.092439</span></span>\"] }, \n",
       "], id: -1023410169, rootId: -1023410169, totalRows: 10 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410169) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 23,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val rebQuantile = (1..10).map {\n",
    "    quantile(it.toDouble() / 100.0, df.reb.toList()).average()\n",
    "}\n",
    "\n",
    "val rebDf = dataFrameOf(\n",
    "    \"Percentile\" to (99 downTo 90).map { it.toDouble() / 100 },\n",
    "    \"reb\" to rebQuantile\n",
    ")\n",
    "\n",
    "rebDf"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "1ce81b44-cbd9-4322-ae66-4ed18ea8c3ea",
   "metadata": {},
   "source": [
    "The players that falls into the top 1% rebounder, for the highest number of seasons are"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 24,
   "id": "3263b309-48cb-41de-9493-412626a6c134",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":11,\"ncol\":3,\"columns\":[\"player_name\",\"Seasons\",\"Avg RPG\"],\"kotlin_dataframe\":[{\"player_name\":\"Andre Drummond\",\"Seasons\":7,\"Avg RPG\":14.585714285714285},{\"player_name\":\"DeAndre Jordan\",\"Seasons\":6,\"Avg RPG\":14.083333333333334},{\"player_name\":\"Dwight Howard\",\"Seasons\":5,\"Avg RPG\":13.960000000000003},{\"player_name\":\"Dennis Rodman\",\"Seasons\":3,\"Avg RPG\":15.133333333333335},{\"player_name\":\"Ben Wallace\",\"Seasons\":3,\"Avg RPG\":13.866666666666667},{\"player_name\":\"Kevin Garnett\",\"Seasons\":3,\"Avg RPG\":13.6},{\"player_name\":\"Kevin Love\",\"Seasons\":3,\"Avg RPG\":14.166666666666666},{\"player_name\":\"Rudy Gobert\",\"Seasons\":3,\"Avg RPG\":13.9},{\"player_name\":\"Jayson Williams\",\"Seasons\":2,\"Avg RPG\":13.55},{\"player_name\":\"Dikembe Mutombo\",\"Seasons\":2,\"Avg RPG\":13.8},{\"player_name\":\"Hassan Whiteside\",\"Seasons\":2,\"Avg RPG\":13.8}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410168\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 11, columnsCount = 3</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"player_name: String\\\">player_name</span>\", children: [], rightAlign: false, values: [\"Andre Drummond\",\"DeAndre Jordan\",\"Dwight Howard\",\"Dennis Rodman\",\"Ben Wallace\",\"Kevin Garnett\",\"Kevin Love\",\"Rudy Gobert\",\"Jayson Williams\",\"Dikembe Mutombo\",\"Hassan Whiteside\"] }, \n",
       "{ name: \"<span title=\\\"Seasons: Int\\\">Seasons</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">7</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">6</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"Avg RPG: Double\\\">Avg RPG</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">14.585714</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">14.083333</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13.960000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">15.133333</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13.866667</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13.600000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">14.166667</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13.900000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13.550000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13.800000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13.800000</span></span>\"] }, \n",
       "], id: -1023410168, rootId: -1023410168, totalRows: 11 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410168) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 24,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "df.filter { reb >= rebDf.reb[0] }\n",
    "    .update { season }.with { it.split('-')[0] }\n",
    "    .convert { season }.toInt()\n",
    "    .groupBy { player_name }.aggregate {\n",
    "        count() into \"Seasons\"\n",
    "        mean { reb } into \"Avg RPG\"\n",
    "    }.sortBy { \"Seasons\"<Int>().desc() }[0..10]"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "53b4737d-fe1a-4bea-ada0-8ec3b6b4538b",
   "metadata": {},
   "source": [
    "We can see that Andre Drummond is the most consistent rebounder, but Dennis Rodman is the best rebounder since 1996."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "472dc09a-c714-4a07-869c-288002b43735",
   "metadata": {},
   "source": [
    "### Assists Per Game"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "0b22cee3-5e57-4b1b-a892-a80b761fe58d",
   "metadata": {
    "tags": []
   },
   "source": [
    "Lastly, we will cover Assists per Game."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 25,
   "id": "850d9cfe-e608-40a1-a78c-548cc2393125",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"Ru8zhl\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Assists per Game Distribution\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"ast\"\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"Assists-per-game\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Games\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"y\":\"..count..\"\n",
       "},\n",
       "\"stat\":\"bin\",\n",
       "\"alpha\":0.8,\n",
       "\"position\":\"stack\",\n",
       "\"binwidth\":1.0,\n",
       "\"geom\":\"histogram\",\n",
       "\"fill\":\"#840032\",\n",
       "\"data\":{\n",
       "\"ast\":[-0.19999999999999996,0.8,1.8,2.8,3.8,4.8,5.8,6.8,7.8,8.8,9.8,10.8,11.8,12.8],\n",
       "\"..count..\":[1136.0,5148.0,2640.0,1387.0,774.0,465.0,316.0,185.0,118.0,79.0,23.0,26.0,8.0,0.0]\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"color\":\"#fcba04\",\n",
       "\"size\":2.0,\n",
       "\"linetype\":\"dashed\",\n",
       "\"position\":\"identity\",\n",
       "\"xintercept\":3.55915481511582,\n",
       "\"geom\":\"vline\",\n",
       "\"data\":{\n",
       "}\n",
       "}],\n",
       "\"theme\":{\n",
       "\"title\":{\n",
       "\"hjust\":0.5,\n",
       "\"blank\":false\n",
       "}\n",
       "}\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"Ru8zhl\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 25,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "ggplot(df.toMap()) { x=\"ast\" } +\n",
    "    geomHistogram(binWidth = 1, fill = \"#840032\", alpha=0.8) { y=\"..count..\" } +\n",
    "    geomVLine(xintercept = df.reb.mean(), color = \"#fcba04\",\n",
    "              size = 2.0, linetype = \"dashed\") +\n",
    "    labs(title=\"Assists per Game Distribution\",\n",
    "         x=\"Assists-per-game\",\n",
    "         y=\"Games\") +\n",
    "    theme(title = elementText(hjust=.5))"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "43423e3d-8ce1-43e9-baaf-1e2b333cf7ef",
   "metadata": {},
   "source": [
    "The mean value is from 3 to 4 assists per game, but the most common values are from one to two.\n",
    "\n",
    "As above, we compute the quantiles from 1 to 10% top assists per game."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 26,
   "id": "88fcc450-cd16-4175-a0fa-0badf1d2bd20",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":10,\"ncol\":2,\"columns\":[\"Percentile\",\"ast\"],\"kotlin_dataframe\":[{\"Percentile\":0.99,\"ast\":9.568292682926824},{\"Percentile\":0.98,\"ast\":8.679268292682936},{\"Percentile\":0.97,\"ast\":8.083739837398372},{\"Percentile\":0.96,\"ast\":7.635365853658534},{\"Percentile\":0.95,\"ast\":7.274796747967484},{\"Percentile\":0.94,\"ast\":6.9719512195121975},{\"Percentile\":0.93,\"ast\":6.708594657375159},{\"Percentile\":0.92,\"ast\":6.474085365853658},{\"Percentile\":0.91,\"ast\":6.26278229448962},{\"Percentile\":0.9,\"ast\":6.070243902439022}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410167\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 10, columnsCount = 2</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"Percentile: Double\\\">Percentile</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.99</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.98</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.97</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.96</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.95</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.94</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.93</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.92</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.91</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0.90</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"ast: Double\\\">ast</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9.568293</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8.679268</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8.083740</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">7.635366</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">7.274797</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">6.971951</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">6.708595</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">6.474085</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">6.262782</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">6.070244</span></span>\"] }, \n",
       "], id: -1023410167, rootId: -1023410167, totalRows: 10 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410167) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 26,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val astQuantile = (1..10).map {\n",
    "    quantile(it.toDouble() / 100.0, df.ast.toList()).average()\n",
    "}\n",
    "\n",
    "val astDf = dataFrameOf(\n",
    "    \"Percentile\" to (99 downTo 90).map { it.toDouble() / 100 },\n",
    "    \"ast\" to astQuantile\n",
    ")\n",
    "\n",
    "astDf"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "1d464e06-6d06-4991-82db-7dc276323bff",
   "metadata": {},
   "source": [
    "And the players with the highest number of seasons averaging the 1% quartile are:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 27,
   "id": "e0c7df33-607e-4b38-affb-9ca8df5509c8",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":11,\"ncol\":3,\"columns\":[\"player_name\",\"Seasons\",\"Ast RPG\"],\"kotlin_dataframe\":[{\"player_name\":\"Chris Paul\",\"Seasons\":9,\"Ast RPG\":10.5},{\"player_name\":\"Steve Nash\",\"Seasons\":8,\"Ast RPG\":10.937500000000002},{\"player_name\":\"Rajon Rondo\",\"Seasons\":6,\"Ast RPG\":10.883333333333335},{\"player_name\":\"Jason Kidd\",\"Seasons\":5,\"Ast RPG\":10.14},{\"player_name\":\"Russell Westbrook\",\"Seasons\":5,\"Ast RPG\":10.7},{\"player_name\":\"Deron Williams\",\"Seasons\":4,\"Ast RPG\":10.5},{\"player_name\":\"John Wall\",\"Seasons\":4,\"Ast RPG\":10.125},{\"player_name\":\"James Harden\",\"Seasons\":3,\"Ast RPG\":10.766666666666666},{\"player_name\":\"Rod Strickland\",\"Seasons\":2,\"Ast RPG\":10.2},{\"player_name\":\"John Stockton\",\"Seasons\":1,\"Ast RPG\":10.5},{\"player_name\":\"Mark Jackson\",\"Seasons\":1,\"Ast RPG\":11.4}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410166\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 11, columnsCount = 3</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"player_name: String\\\">player_name</span>\", children: [], rightAlign: false, values: [\"Chris Paul\",\"Steve Nash\",\"Rajon Rondo\",\"Jason Kidd\",\"Russell Westbrook\",\"Deron Williams\",\"John Wall\",\"James Harden\",\"Rod Strickland\",\"John Stockton\",\"Mark Jackson\"] }, \n",
       "{ name: \"<span title=\\\"Seasons: Int\\\">Seasons</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">6</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">4</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">4</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"Ast RPG: Double\\\">Ast RPG</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.500000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.937500</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.883333</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.140000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.700000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.500000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.125000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.766667</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.200000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.500000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">11.400000</span></span>\"] }, \n",
       "], id: -1023410166, rootId: -1023410166, totalRows: 11 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410166) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 27,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "df.filter { ast >= astDf.ast[0] }\n",
    "    .update { season }.with { it.split('-')[0] }\n",
    "    .convert { season }.toInt()\n",
    "    .groupBy { player_name }.aggregate {\n",
    "        count() into \"Seasons\"\n",
    "        mean { ast } into \"Ast RPG\"\n",
    "    }.sortBy { \"Seasons\"<Int>().desc() }[0..10]"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "ad5fb9e5-577a-4e32-a0dc-fcef336a0a53",
   "metadata": {},
   "source": [
    "Chris Paul is the most consistent of all players from 1996 to today when it comes to assists per game, where Rajon Rondo has the best assist per game season:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 28,
   "id": "5989548e-6b07-4f05-9fbb-37f33b6ab72b",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":1,\"ncol\":2,\"columns\":[\"player_name\",\"ast\"],\"kotlin_dataframe\":[{\"player_name\":\"Rajon Rondo\",\"ast\":11.7}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410165\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataRow: index = 0, columnsCount = 2</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"player_name: String\\\">player_name</span>\", children: [], rightAlign: false, values: [\"Rajon Rondo\"] }, \n",
       "{ name: \"<span title=\\\"ast: Double\\\">ast</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">11.7</span></span>\"] }, \n",
       "], id: -1023410165, rootId: -1023410165, totalRows: 1 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410165) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 28,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "df.sortBy { ast.desc() }.select { player_name and ast }[0]"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "82870338-730b-4eb1-9f41-45403a6fc8de",
   "metadata": {},
   "source": [
    "## College Ranking"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "c7d67da2-78db-41f7-83cf-c50861714e6d",
   "metadata": {},
   "source": [
    "The last section will summarize the above statics (points, rebounds, assists)"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "ed0e9893-b68d-420e-b9a7-4144f83a8167",
   "metadata": {},
   "source": [
    "Let's create a college ranking based on player's total games played in NBA"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 29,
   "id": "096b2288-a155-4d88-bf7b-c270dfe71ab2",
   "metadata": {
    "tags": []
   },
   "outputs": [],
   "source": [
    "val careerGames = df.groupBy { player_name }.sum { gp }\n",
    "\n",
    "val college_rank = careerGames.join(df) { player_name match right.player_name }\n",
    "    .select { player_name and college and gp }\n",
    "    .distinctBy { player_name }\n",
    "    .rename { gp }.into(\"total_games\")\n",
    "    .groupBy { college }.sum(\"total_games\")\n",
    "    .sortByDesc(\"total_games\")\n",
    "    .filter { college != \"None\" }.add(\"rank\") { index() }"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 30,
   "id": "a204f2f8-6226-4829-a5fd-312eba6cf209",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":11,\"ncol\":3,\"columns\":[\"college\",\"total_games\",\"rank\"],\"kotlin_dataframe\":[{\"college\":\"Kentucky\",\"total_games\":23051,\"rank\":0},{\"college\":\"Duke\",\"total_games\":20584,\"rank\":1},{\"college\":\"North Carolina\",\"total_games\":19723,\"rank\":2},{\"college\":\"UCLA\",\"total_games\":16444,\"rank\":3},{\"college\":\"Arizona\",\"total_games\":15569,\"rank\":4},{\"college\":\"Kansas\",\"total_games\":15269,\"rank\":5},{\"college\":\"Connecticut\",\"total_games\":13552,\"rank\":6},{\"college\":\"Georgia Tech\",\"total_games\":10409,\"rank\":7},{\"college\":\"Florida\",\"total_games\":10402,\"rank\":8},{\"college\":\"Michigan\",\"total_games\":9516,\"rank\":9},{\"college\":\"Texas\",\"total_games\":9345,\"rank\":10}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410164\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 11, columnsCount = 3</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"college: String\\\">college</span>\", children: [], rightAlign: false, values: [\"Kentucky\",\"Duke\",\"North Carolina\",\"UCLA\",\"Arizona\",\"Kansas\",\"Connecticut\",\"Georgia Tech\",\"Florida\",\"Michigan\",\"Texas\"] }, \n",
       "{ name: \"<span title=\\\"total_games: Int\\\">total_games</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">23051</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">20584</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">19723</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">16444</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">15569</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">15269</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13552</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10409</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10402</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9516</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9345</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"rank: Int\\\">rank</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">4</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">6</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">7</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10</span></span>\"] }, \n",
       "], id: -1023410164, rootId: -1023410164, totalRows: 11 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410164) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 30,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "college_rank[0..10]"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "f995f700-4149-4b8a-a32b-fcd3080ff060",
   "metadata": {},
   "source": [
    "We can then plot player's best **points-per-game** season, showing the rank of the college he comes from"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 31,
   "id": "56912530-a503-448d-82cf-87298d7896d2",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":11,\"ncol\":4,\"columns\":[\"player_name\",\"pts\",\"college\",\"rank\"],\"kotlin_dataframe\":[{\"player_name\":\"Kevin Durant\",\"pts\":27.099999999999994,\"college\":\"Texas\",\"rank\":10},{\"player_name\":\"Allen Iverson\",\"pts\":26.064285714285713,\"college\":\"Georgetown\",\"rank\":12},{\"player_name\":\"Trae Young\",\"pts\":25.6,\"college\":\"Oklahoma\",\"rank\":58},{\"player_name\":\"Joel Embiid\",\"pts\":25.45,\"college\":\"Kansas\",\"rank\":5},{\"player_name\":\"Michael Jordan\",\"pts\":25.299999999999997,\"college\":\"North Carolina\",\"rank\":2},{\"player_name\":\"James Harden\",\"pts\":24.853846153846156,\"college\":\"Arizona State\",\"rank\":59},{\"player_name\":\"Damian Lillard\",\"pts\":24.830000000000005,\"college\":\"Weber State\",\"rank\":110},{\"player_name\":\"Zion Williamson\",\"pts\":24.75,\"college\":\"Duke\",\"rank\":1},{\"player_name\":\"Donovan Mitchell\",\"pts\":24.119999999999997,\"college\":\"Louisville\",\"rank\":33},{\"player_name\":\"Devin Booker\",\"pts\":23.771428571428572,\"college\":\"Kentucky\",\"rank\":0},{\"player_name\":\"Stephen Curry\",\"pts\":23.761538461538464,\"college\":\"Davidson\",\"rank\":116}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410163\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 11, columnsCount = 4</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"player_name: String\\\">player_name</span>\", children: [], rightAlign: false, values: [\"Kevin Durant\",\"Allen Iverson\",\"Trae Young\",\"Joel Embiid\",\"Michael Jordan\",\"James Harden\",\"Damian Lillard\",\"Zion Williamson\",\"Donovan Mitchell\",\"Devin Booker\",\"Stephen Curry\"] }, \n",
       "{ name: \"<span title=\\\"pts: Double\\\">pts</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">27.100000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">26.064286</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">25.600000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">25.450000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">25.300000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">24.853846</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">24.830000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">24.750000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">24.120000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">23.771429</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">23.761538</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"college: String\\\">college</span>\", children: [], rightAlign: false, values: [\"Texas\",\"Georgetown\",\"Oklahoma\",\"Kansas\",\"North Carolina\",\"Arizona State\",\"Weber State\",\"Duke\",\"Louisville\",\"Kentucky\",\"Davidson\"] }, \n",
       "{ name: \"<span title=\\\"rank: Int\\\">rank</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">12</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">58</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">59</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">110</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">1</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">33</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">116</span></span>\"] }, \n",
       "], id: -1023410163, rootId: -1023410163, totalRows: 11 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410163) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 31,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val bestScorer = df.groupBy { player_name }.mean { pts }.sortBy { pts.desc() }\n",
    "                    .join(\n",
    "                        df.distinctBy { player_name }\n",
    "                            .select { player_name and college } \n",
    "                    ) { player_name match right.player_name }\n",
    "                    .filter { college != \"None\" }\n",
    "                    .join(\n",
    "                        college_rank.select { college and rank }\n",
    "                    ) { college match right.college }\n",
    "\n",
    "\n",
    "bestScorer[0..10]"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 40,
   "id": "bcbe091c-14f6-477b-a32e-be8b1cd02c17",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"Zqp4x7\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Average PPG with College Ranking\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"player_name\",\n",
       "\"y\":\"pts\"\n",
       "},\n",
       "\"coord\":{\n",
       "\"name\":\"flip\",\n",
       "\"flip\":true\n",
       "},\n",
       "\"data\":{\n",
       "\"college\":[\"Texas\",\"Georgetown\",\"Oklahoma\",\"Kansas\",\"North Carolina\",\"Arizona State\",\"Weber State\",\"Duke\",\"Louisville\",\"Kentucky\",\"Davidson\",\"Kentucky\",\"Kentucky\",\"Duke\",\"UCLA\",\"Louisiana Tech\"],\n",
       "\"rank\":[10.0,12.0,58.0,5.0,2.0,59.0,110.0,1.0,33.0,0.0,116.0,0.0,0.0,1.0,3.0,65.0],\n",
       "\"player_name\":[\"Kevin Durant\",\"Allen Iverson\",\"Trae Young\",\"Joel Embiid\",\"Michael Jordan\",\"James Harden\",\"Damian Lillard\",\"Zion Williamson\",\"Donovan Mitchell\",\"Devin Booker\",\"Stephen Curry\",\"Anthony Davis\",\"Karl-Anthony Towns\",\"Kyrie Irving\",\"Russell Westbrook\",\"Karl Malone\"],\n",
       "\"pts\":[27.099999999999994,26.064285714285713,25.6,25.45,25.299999999999997,24.853846153846156,24.830000000000005,24.75,24.119999999999997,23.771428571428572,23.761538461538464,23.61,23.571428571428573,23.472727272727273,22.95,22.8875]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"Points-per-Game\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Player\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"fill\":\"rank\"\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"bar\",\n",
       "\"tooltips\":{\n",
       "\"lines\":[\"college|@college\",\"rank|@rank \"]\n",
       "},\n",
       "\"data\":{\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"Zqp4x7\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 40,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val tooltipOptions = layerTooltips()\n",
    "                        .line(\"college|@college\")\n",
    "                        .line(\"rank|@rank \")\n",
    "    \n",
    "    \n",
    "ggplot(bestScorer[0..15].toMap()) { x=\"player_name\" ; y=\"pts\" } +\n",
    "    geomBar(stat = Stat.identity, tooltips = tooltipOptions) { fill=\"rank\" } +\n",
    "    coordFlip() +\n",
    "    labs(title = \"Average PPG with College Ranking\",\n",
    "         x = \"Points-per-Game\",\n",
    "         y = \"Player\")"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "f5373c29-a633-44ba-9705-b2b35bb46869",
   "metadata": {},
   "source": [
    "We can see that the higher the rank of the college is, the higher is the number of players in the top 15 scorer."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "abcb0d9d-36c9-4545-9db6-d454167f9b2c",
   "metadata": {},
   "source": [
    "Let's see if this is true also for rebounds and assists."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 42,
   "id": "9c370982-74eb-4732-9e54-ff2ffcbd0bc7",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":11,\"ncol\":4,\"columns\":[\"player_name\",\"ast\",\"college\",\"rank\"],\"kotlin_dataframe\":[{\"player_name\":\"Chris Paul\",\"ast\":9.482352941176472,\"college\":\"Wake Forest\",\"rank\":13},{\"player_name\":\"Trae Young\",\"ast\":9.125,\"college\":\"Oklahoma\",\"rank\":58},{\"player_name\":\"John Wall\",\"ast\":8.88,\"college\":\"Kentucky\",\"rank\":0},{\"player_name\":\"Jason Kidd\",\"ast\":8.68235294117647,\"college\":\"California\",\"rank\":23},{\"player_name\":\"John Stockton\",\"ast\":8.528571428571428,\"college\":\"Gonzaga\",\"rank\":35},{\"player_name\":\"Russell Westbrook\",\"ast\":8.392857142857142,\"college\":\"UCLA\",\"rank\":3},{\"player_name\":\"Steve Nash\",\"ast\":8.16111111111111,\"college\":\"Santa Clara\",\"rank\":94},{\"player_name\":\"Deron Williams\",\"ast\":8.024999999999999,\"college\":\"Illinois\",\"rank\":44},{\"player_name\":\"Rajon Rondo\",\"ast\":7.937500000000002,\"college\":\"Kentucky\",\"rank\":0},{\"player_name\":\"Terrell Brandon\",\"ast\":7.883333333333333,\"college\":\"Oregon\",\"rank\":42},{\"player_name\":\"Ben Simmons\",\"ast\":7.699999999999999,\"college\":\"Louisiana State\",\"rank\":17}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410161\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 11, columnsCount = 4</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"player_name: String\\\">player_name</span>\", children: [], rightAlign: false, values: [\"Chris Paul\",\"Trae Young\",\"John Wall\",\"Jason Kidd\",\"John Stockton\",\"Russell Westbrook\",\"Steve Nash\",\"Deron Williams\",\"Rajon Rondo\",\"Terrell Brandon\",\"Ben Simmons\"] }, \n",
       "{ name: \"<span title=\\\"ast: Double\\\">ast</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9.482353</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">9.125000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8.880000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8.682353</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8.528571</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8.392857</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8.161111</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">8.025000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">7.937500</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">7.883333</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">7.700000</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"college: String\\\">college</span>\", children: [], rightAlign: false, values: [\"Wake Forest\",\"Oklahoma\",\"Kentucky\",\"California\",\"Gonzaga\",\"UCLA\",\"Santa Clara\",\"Illinois\",\"Kentucky\",\"Oregon\",\"Louisiana State\"] }, \n",
       "{ name: \"<span title=\\\"rank: Int\\\">rank</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">58</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">23</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">35</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">94</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">44</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">42</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">17</span></span>\"] }, \n",
       "], id: -1023410161, rootId: -1023410161, totalRows: 11 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410161) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 42,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val bestAst = df.groupBy { player_name }.mean { ast }.sortBy { ast.desc() }\n",
    "                    .join(\n",
    "                        df.distinctBy { player_name }\n",
    "                            .select { player_name and college } \n",
    "                    ) { player_name match right.player_name }\n",
    "                    .filter { college != \"None\" }\n",
    "                    .join(\n",
    "                        college_rank.select { college and rank }\n",
    "                    ) { college match right.college }\n",
    "\n",
    "bestAst[0..10]"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 43,
   "id": "4de22def-9af2-4c1e-8a8b-388e9106210e",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"kxlbQF\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Average APG with College Ranking\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"player_name\",\n",
       "\"y\":\"ast\"\n",
       "},\n",
       "\"coord\":{\n",
       "\"name\":\"flip\",\n",
       "\"flip\":true\n",
       "},\n",
       "\"data\":{\n",
       "\"college\":[\"Wake Forest\",\"Oklahoma\",\"Kentucky\",\"California\",\"Gonzaga\",\"UCLA\",\"Santa Clara\",\"Illinois\",\"Kentucky\",\"Oregon\",\"Louisiana State\",\"Michigan\",\"St. John's (NY)\",\"Georgia Tech\",\"UCLA\",\"Murray State\"],\n",
       "\"ast\":[9.482352941176472,9.125,8.88,8.68235294117647,8.528571428571428,8.392857142857142,8.16111111111111,8.024999999999999,7.937500000000002,7.883333333333333,7.699999999999999,7.5,7.35,7.253846153846155,7.161538461538462,7.133333333333333],\n",
       "\"rank\":[13.0,58.0,0.0,23.0,35.0,3.0,94.0,44.0,0.0,42.0,17.0,9.0,38.0,7.0,3.0,90.0],\n",
       "\"player_name\":[\"Chris Paul\",\"Trae Young\",\"John Wall\",\"Jason Kidd\",\"John Stockton\",\"Russell Westbrook\",\"Steve Nash\",\"Deron Williams\",\"Rajon Rondo\",\"Terrell Brandon\",\"Ben Simmons\",\"Zavier Simpson\",\"Mark Jackson\",\"Stephon Marbury\",\"Baron Davis\",\"Ja Morant\"]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"Assists-per-Game\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Player\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"fill\":\"rank\"\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"bar\",\n",
       "\"tooltips\":{\n",
       "\"lines\":[\"college|@college\",\"rank|@rank \"]\n",
       "},\n",
       "\"data\":{\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"kxlbQF\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 43,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "ggplot(bestAst[0..15].toMap()) { x=\"player_name\" ; y=\"ast\" } +\n",
    "    geomBar(stat = Stat.identity, tooltips = tooltipOptions) { fill=\"rank\" } +\n",
    "    coordFlip() +\n",
    "    labs(title = \"Average APG with College Ranking\",\n",
    "         x = \"Assists-per-Game\",\n",
    "         y = \"Player\")"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "53fe32bc-88c2-43c0-a32b-49f4bbb97bb2",
   "metadata": {},
   "source": [
    "When it comes to top 15 player's assists per game, the college ranking distribution is very similar to the point per game one, with the top 5 with an average ranking of 25."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 44,
   "id": "b1ac3c29-887b-427d-be6c-97f0af41d7de",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":11,\"ncol\":4,\"columns\":[\"player_name\",\"reb\",\"college\",\"rank\"],\"kotlin_dataframe\":[{\"player_name\":\"Dennis Rodman\",\"reb\":14.149999999999999,\"college\":\"Southeastern Oklahoma State\",\"rank\":204},{\"player_name\":\"Andre Drummond\",\"reb\":13.1,\"college\":\"Connecticut\",\"rank\":6},{\"player_name\":\"Jayson Williams\",\"reb\":13.033333333333333,\"college\":\"St. John's (NY)\",\"rank\":38},{\"player_name\":\"Charles Barkley\",\"reb\":12.0,\"college\":\"Auburn\",\"rank\":68},{\"player_name\":\"Karl-Anthony Towns\",\"reb\":11.242857142857142,\"college\":\"Kentucky\",\"rank\":0},{\"player_name\":\"Joel Embiid\",\"reb\":11.049999999999999,\"college\":\"Kansas\",\"rank\":5},{\"player_name\":\"Tim Duncan\",\"reb\":10.76842105263158,\"college\":\"Wake Forest\",\"rank\":13},{\"player_name\":\"Kevin Love\",\"reb\":10.742857142857144,\"college\":\"UCLA\",\"rank\":3},{\"player_name\":\"Deandre Ayton\",\"reb\":10.625,\"college\":\"Arizona\",\"rank\":4},{\"player_name\":\"Nikola Vucevic\",\"reb\":10.245454545454546,\"college\":\"Southern California\",\"rank\":22},{\"player_name\":\"Anthony Davis\",\"reb\":10.07,\"college\":\"Kentucky\",\"rank\":0}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_-1023410160\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 11, columnsCount = 4</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"player_name: String\\\">player_name</span>\", children: [], rightAlign: false, values: [\"Dennis Rodman\",\"Andre Drummond\",\"Jayson Williams\",\"Charles Barkley\",\"Karl-Anthony Towns\",\"Joel Embiid\",\"Tim Duncan\",\"Kevin Love\",\"Deandre Ayton\",\"Nikola Vucevic\",\"Anthony Davis\"] }, \n",
       "{ name: \"<span title=\\\"reb: Double\\\">reb</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">14.150000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13.100000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13.033333</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">12.000000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">11.242857</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">11.050000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.768421</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.742857</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.625000</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.245455</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">10.070000</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"college: String\\\">college</span>\", children: [], rightAlign: false, values: [\"Southeastern Oklahoma State\",\"Connecticut\",\"St. John&#39;s (NY)\",\"Auburn\",\"Kentucky\",\"Kansas\",\"Wake Forest\",\"UCLA\",\"Arizona\",\"Southern California\",\"Kentucky\"] }, \n",
       "{ name: \"<span title=\\\"rank: Int\\\">rank</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">204</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">6</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">38</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">68</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">13</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">4</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">22</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">0</span></span>\"] }, \n",
       "], id: -1023410160, rootId: -1023410160, totalRows: 11 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(-1023410160) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 44,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val bestReb = df.groupBy { player_name }.mean { reb }.sortByDesc { reb }\n",
    "                    .join(\n",
    "                        df.distinctBy { player_name }\n",
    "                            .select { player_name and college } \n",
    "                    ) { player_name match right.player_name }\n",
    "                    .filter { college != \"None\" }\n",
    "                    .join(\n",
    "                        college_rank.select { college and rank }\n",
    "                    ) { college match right.college }\n",
    "\n",
    "bestReb[0..10]"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 46,
   "id": "45e049ec-143a-41da-bfd4-d4dee059d49a",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"oto53G\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Average RPG with College Ranking\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"player_name\",\n",
       "\"y\":\"reb\"\n",
       "},\n",
       "\"coord\":{\n",
       "\"name\":\"flip\",\n",
       "\"flip\":true\n",
       "},\n",
       "\"data\":{\n",
       "\"college\":[\"Southeastern Oklahoma State\",\"Connecticut\",\"St. John's (NY)\",\"Auburn\",\"Kentucky\",\"Kansas\",\"Wake Forest\",\"UCLA\",\"Arizona\",\"Southern California\",\"Kentucky\",\"Louisiana State\",\"Texas A&M\",\"Kentucky\",\"Gonzaga\",\"Duke\"],\n",
       "\"rank\":[204.0,6.0,38.0,68.0,0.0,5.0,13.0,3.0,4.0,22.0,0.0,17.0,61.0,0.0,35.0,1.0],\n",
       "\"player_name\":[\"Dennis Rodman\",\"Andre Drummond\",\"Jayson Williams\",\"Charles Barkley\",\"Karl-Anthony Towns\",\"Joel Embiid\",\"Tim Duncan\",\"Kevin Love\",\"Deandre Ayton\",\"Nikola Vucevic\",\"Anthony Davis\",\"Shaquille O'Neal\",\"DeAndre Jordan\",\"DeMarcus Cousins\",\"Domantas Sabonis\",\"Carlos Boozer\"],\n",
       "\"reb\":[14.149999999999999,13.1,13.033333333333333,12.0,11.242857142857142,11.049999999999999,10.76842105263158,10.742857142857144,10.625,10.245454545454546,10.07,10.013333333333334,9.978571428571428,9.954545454545455,9.516666666666667,9.476923076923075]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[{\n",
       "\"aesthetic\":\"x\",\n",
       "\"name\":\"Rebounds-per-Game\"\n",
       "},{\n",
       "\"aesthetic\":\"y\",\n",
       "\"name\":\"Player\"\n",
       "}],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"fill\":\"rank\"\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"bar\",\n",
       "\"tooltips\":{\n",
       "\"lines\":[\"college|@college\",\"rank|@rank \"]\n",
       "},\n",
       "\"data\":{\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"oto53G\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 46,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "ggplot(bestReb[0..15].toMap()) { x=\"player_name\" ; y=\"reb\" } +\n",
    "    geomBar(stat = Stat.identity, tooltips = tooltipOptions) { fill=\"rank\" } +\n",
    "    coordFlip() +\n",
    "    labs(title = \"Average RPG with College Ranking\",\n",
    "         x = \"Rebounds-per-Game\",\n",
    "         y = \"Player\")"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "c8ac99bf-2efc-4fc8-a07c-6b441d95f0db",
   "metadata": {},
   "source": [
    "Dennis Rodman is the best rebounder since 1996, and in his case, the college ranking did not matter. For the rest of the top 15, the college ranking is fairly low among best rebounders (max. 68)."
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Kotlin",
   "language": "kotlin",
   "name": "kotlin"
  },
  "language_info": {
   "codemirror_mode": "text/x-kotlin",
   "file_extension": ".kt",
   "mimetype": "text/x-kotlin",
   "name": "kotlin",
   "nbconvert_exporter": "",
   "pygments_lexer": "kotlin",
   "version": "1.8.20"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
